#!/usr/bin/perl
#
#
# BNCweb: A user-friendly interface to the British National Corpus - Version 4.0
# Copyright (C) 2005-7 Hoffmann/Evert/Lehmann
#
# Updates and information available at http://www.bncweb.info
#
# This file is part of BNCweb.
# 
# BNCweb is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
# 
# BNCweb is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
# based on BNCweb Version 2.0:
#  1996/2004 Lehmann/Hoffmann/Schneider
#

print "Content-Type: text/text\n";
print "Content-disposition: attachment; filename=collocations.txt\n\n";

$|=1;
use DBI;
use bncLibCQPXML;

# connect to mysql
$bncHandle = DBI->connect("DBI:mysql:$bwMYSQLtable:$bwMYSQLhost:$bwMysqlPort", "$bwMysqlUser", "$bwMysqlPwd") or barkFull("Can't connect to mysql on $bwMYSQLhost at port: $bwMysqlPort <BR>" . $userHandle::errstr);
$userHandle = DBI->connect("DBI:mysql:$bwMYSQLusertable:$bwMYSQLhost:$bwMysqlPort", "$bwMysqlUser", "$bwMysqlPwd") or barkFull("Can't connect to mysql on $bwMYSQLhost at port: $bwMysqlPort <BR>" . $userHandle::errstr);
$frequencyHandle = DBI->connect("DBI:mysql:$bwMYSQLfrequency:$bwMYSQLhost:$bwMysqlPort", "$bwMysqlUser", "$bwMysqlPwd") or bark("Can't connect to mysql on $bwMYSQLhost at port: $bwMysqlPort <BR>" . $frequencyHandle::errstr);

$username = $ENV{'REMOTE_USER'};

unless (getParams($ENV{'QUERY_STRING'})) {
	barkFull("incomplete transmition of URL<BR>This problem is likely to occur in combination with proxy servers<BR>turn off your web-proxy and try again");
}

$dbname = $params{dbname};
$numOfSolutions = $params{numOfSolutions};

$theDataShow=$params{theData};
$theDataShow =~ s/\650/\'/go;
$theDataShow=~s/\</&lt\;/g;
$theDataShow=~s/\>/&gt\;/g;

$wordClean=$params{word};
$wordClean=~s/ /~/g;

$tagClean=$params{tag};

$hitGroupTag=0;
$check=$tagClean=~m/(ADJ|ADV|ART|CONJ|INTERJ|PREP|PRON|SUBST|VERB|UNC|STOP)/;
$hitGroupTag=1 if ($check);

$having = "HAVING sum >= $params{delRare}";

$windowSize=$params{plus} - $params{minus};
$windowSize++ if (($params{plus} < 0) || ($params{minus} > 0));

$crlf = &linefeed();

print "Collocation Database$crlf$crlf";
$limitString="";

# set variables for different calculations of collocation values depending on sub-corpus chosen
$subcorpus = &subcorpusCheck($params{thMode});


if ((!$subcorpus) || ($params{basis} == 1)) {
	if ($params{coll} == 1) {
		$wordFreq="$bwMYSQLtable.tags_overall";
	} elsif ($params{coll} == 2) {
		$wordFreq="$bwMYSQLtable.allLemma";
	} else {
		$wordFreq="$bwMYSQLtable.allWords";
		if ($tagClean ne "all") {
			$wordFreq="$bwMYSQLtable.allWordsT";
			$wordFreq="$bwMYSQLtable.allWordsG" if ($hitGroupTag);
		}
	}
	$dispBasis="the whole BNC";			
	$totBasis=112102325 * $params{thinning};
} elsif (($subcorpus eq "(spowri=1") || ($params{basis} == 2)) {
	if ($params{coll} == 1) {
		$wordFreq="$bwMYSQLtable.tags_written";
	} elsif ($params{coll} == 2) {
		$wordFreq="$bwMYSQLtable.allLemmaW";
	} else {
		$wordFreq="$bwMYSQLtable.allWordsW";
		if ($tagClean ne "all") {
			$wordFreq="$bwMYSQLtable.allWordsTW";
			$wordFreq="$bwMYSQLtable.allWordsWG" if ($hitGroupTag);
		}
	}
	$dispBasis="written texts";
	$totBasis=100119205 * $params{thinning};
} elsif (($subcorpus eq "(spowri=2") || ($params{basis} == 3)) {
	if ($params{coll} == 1) {
		$wordFreq="$bwMYSQLtable.tags_spoken";
	} elsif ($params{coll} == 2) {
		$wordFreq="$bwMYSQLtable.allLemmaW";
	} else {
		$wordFreq="$bwMYSQLtable.allWordsS";
		if ($tagClean ne "all") {
			$wordFreq="$bwMYSQLtable.allWordsTS";
			$wordFreq="$bwMYSQLtable.allWordsSG" if ($hitGroupTag);
		}
	}
	$dispBasis="spoken texts";
	$totBasis=11983120 * $params{thinning};
} else {
	$cachedName = $params{fListCache};
	if ($params{coll} == 1) {
		#doesn't work for subcorpor - disable!
		$wordFreq="$bwMYSQLfrequency.tags_spoken";
	} elsif ($params{coll} == 2) {
		$wordFreq="$bwMYSQLfrequency.allLemma_$cachedName";
	} else {
		$wordFreq="$bwMYSQLfrequency.allWords_$cachedName";
		if ($tagClean ne "all") {
			$wordFreq="$bwMYSQLfrequency.allWordsT_$cachedName";
			$wordFreq="$bwMYSQLfrequency.allWordsG_$cachedName" if ($hitGroupTag);
		}
	}
	$dispBasis="current subcorpus";

	$sqlQuery = "SELECT sum(freq) FROM allWords_$cachedName";
	$sth = $frequencyHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $frequencyHandle::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	@rowArray=$sth->fetchrow_array;
	$totBasis = $rowArray[0] * $params{thinning};
}

$colVal=0;
$colVal=1 unless ($params{statType}== 4);
	
if ($params{plus} ne $params{minus}) {
	$rangeString="dist BETWEEN $params{minus} AND $params{plus}";
} else {
	$rangeString="dist = $params{plus}";
}

if ($params{coll} == 2) {
	$sqlQuery = "SELECT distinct(lemma) FROM $dbname";
	$sth= $userHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $userHandle::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	$typesTotal = $sth->rows;
	$blurb = "lemmata";
} else {
	$sqlQuery = "SELECT distinct(item) FROM $dbname";
	$sth= $userHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $userHandle::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	$typesTotal = $sth->rows;
	$blurb = "types";
}

#$check = $params{thMode}=~m/\AM(\d+)#?/;


$titleBar = &createTitle($params{thMode}, $theDataShow, $numOfSolutions);
$titleBar=~s/\&quot\;/\"/g;
$titleBar=~s/<[^>]+>//g;
print "There are $typesTotal different $blurb in your collocation database for the query \"$theDataShow\". ($titleBar)$crlf";

$theMinus="\xAD";
$baseOfCalc="Mutual information" if ($params{statType} == 1);
$baseOfCalc="Log-likelihood" if ($params{statType} == 2);
$baseOfCalc="Log-log" if ($params{statType} == 3);
$baseOfCalc="Rank by frequency" if ($params{statType} == 4);
$baseOfCalc="Observed / expected" if ($params{statType} == 5);
$baseOfCalc="Z-score" if ($params{statType} == 6);
$baseOfCalc="MI3" if ($params{statType} == 7);
$baseOfCalc="Log-likelihood (negative)" if ($params{statType} == 8);

if (!$params{coll}) {
	if ($tagClean ne "all") {
		$check=$tagClean=~m/(ADJ|ADV|ART|CONJ|INTERJ|PREP|PRON|SUBST|VERB|UNC|STOP)/;
		if ($check) {
			$value=$1;
			$lemma_tag = 1;
			# for the display when downloading result
			$tagRestriction="any verb" if ($value eq "VERB");
			$tagRestriction="any noun" if ($value eq "SUBST");
			$tagRestriction="any adjective" if ($value eq "ADJ");
			$tagRestriction="any adverb" if ($value eq "ADV");
			$tagRestriction="any pronoun" if ($value eq "PRON");
			$tagRestriction="any preposition" if ($value eq "PREP");
			$tagRestriction="any conjunction" if ($value eq "CONJ");
			$tagRestriction="any article" if ($value eq "ART");
			$tagRestriction="any interjection" if ($value eq "INTERJ");
			$tagRestriction="any punctuation" if ($value eq "STOP");
			$tagRestriction="any unclear" if ($value eq "UNC");
			
			# for the SQL-query (allWordsT etc. have different tags...)
			
			$pos = class2cpos($value);
			$concatTag="_" . $tagClean;
			$tagRegexp = "and $bwMYSQLusertable.$dbname.tag regexp \'$pos\' ";
		} else {
			$concatTag="_" . $tagClean;
			$tagRestriction = $tagClean;
			$tagRegexp = "and $bwMYSQLusertable.$dbname.tag = \'$tagClean\' ";
		}
		$concatWord="concat($bwMYSQLusertable.$dbname.item, \"$concatTag\")";
	} else {
		$concatWord="$bwMYSQLusertable.$dbname.item";
		$tagRegexp = "";
		$tagRestriction="";
	}
	$itemOrTag="$bwMYSQLusertable.$dbname.item";
	$basisWordOrTag="$wordFreq.word";
	$displayWord ="Collocation";
} elsif ($params{coll} == 2) {
	$tagRestriction="";
	$tagRegexp = "";
	$concatWord="$bwMYSQLusertable.$dbname.lemma";
	$itemOrTag= "$bwMYSQLusertable.$dbname.lemma";
	if ($params{lemmaType}) {
		$tagRegexp = " AND $concatWord regexp '_$params{lemmaType}' ";
	}
	$basisWordOrTag="$wordFreq.lemma";
	$displayWord ="Lemma collocation";
} else {
	$tagRestriction="";
	$tagRegexp = "";
	$concatWord="$bwMYSQLusertable.$dbname.tag";
	$itemOrTag="$bwMYSQLusertable.$dbname.tag";
	$basisWordOrTag="$wordFreq.tag";
	$limitString="";
	$displayWord ="Colligation";
}

print "The selected range was $params{minus} to $params{plus}.$crlf";
print "Corpus basis for calculation: $dispBasis. $crlf";
print "Type of calculation: $baseOfCalc $crlf" unless ($params{word});
print "Tag restriction: $tagRestriction $crlf" if ($tagRestriction);
print "Collocates occur at least $params{totfreq} times in $dispBasis. $crlf";
print "Words collocate at least $params{delRare} times. $crlf";

if ($params{thinning} != 1) {
	$thinFactor = "* $params{thinning}";
} else {
	$thinFactor = "";
}	

if (!$params{word}) {
	if ($colVal) {
		print "------------------------------------------------------------------------------$crlf";
		if (!$params{coll}) {
			print "No.\tWord\tn\tn coll.\tn texts\tColl. value $crlf";
		} elsif ($params{coll} == 2) {
			print "No.\tLemma\tn\tn coll.\tn texts\tColl. value $crlf";
		} else {
			print "No.\tTag\tn\tn coll.\tn texts\tColl. value $crlf";
		}
		print "------------------------------------------------------------------------------$crlf";
		

		if ($params{statType}== 1) {

#			$sqlQuery="select $itemOrTag, count($itemOrTag) as sum,
#				(log(count($itemOrTag)) - log($wordFreq.freq $thinFactor * $windowSize * $numOfSolutions / $totBasis))
#				/ log(2) as result, $wordFreq.freq, count(distinct(fname))
#				from $bwMYSQLusertable.$dbname, $wordFreq
#				where $concatWord = $basisWordOrTag
#				and $rangeString
#				$tagRegexp
#				and $wordFreq.freq >= $params{totfreq}
#				group by $itemOrTag
#				$having
#				order by result desc $limitString";


			$sqlQuery="select $itemOrTag, count($itemOrTag) as sum,
				log((1 / $windowSize) * ((count($itemOrTag) * $totBasis) / ($wordFreq.freq $thinFactor * $numOfSolutions))) / log(2)
				as result, $wordFreq.freq, count(distinct(fname))
				from $bwMYSQLusertable.$dbname, $wordFreq 
				where $concatWord = $basisWordOrTag
				and $rangeString
				$tagRegexp
				and $wordFreq.freq >= $params{totfreq}
				group by $itemOrTag
				$having
				order by result desc $limitString";

		} elsif (($params{statType} == 2) || ($params{statType} == 8)) {
			if ($params{statType} == 2) {
				$descAsc = "desc";
			} else {
				$descAsc = "asc";
			}
			$sqlQuery="select $itemOrTag, count($itemOrTag) as sum,
				2 * (count($itemOrTag) * log(count($itemOrTag))
				+ ($numOfSolutions - count($itemOrTag)) * log(($numOfSolutions - count($itemOrTag))) 
				+ (($wordFreq.freq $thinFactor) - count($itemOrTag)) * log((($wordFreq.freq $thinFactor) - count($itemOrTag))) 
				+ ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)) 
				* log(($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)))
				- (count($itemOrTag) + ($numOfSolutions - count($itemOrTag))) 
				* log(count($itemOrTag) + ($numOfSolutions - count($itemOrTag)))
				- (count($itemOrTag) + (($wordFreq.freq $thinFactor) - count($itemOrTag))) 
				* log(count($itemOrTag) + (($wordFreq.freq $thinFactor) - count($itemOrTag)))
				- (($numOfSolutions - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag))) 
				* log(($numOfSolutions - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)))
				- ((($wordFreq.freq $thinFactor) - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag))) 
				* log((($wordFreq.freq $thinFactor) - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)))
				+ (count($itemOrTag) + ($numOfSolutions - count($itemOrTag)) + (($wordFreq.freq $thinFactor) - count($itemOrTag))
				+ ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag))) * log(count($itemOrTag) 
				+ ($numOfSolutions - count($itemOrTag)) + (($wordFreq.freq $thinFactor) - count($itemOrTag)) 
				+ ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)))) * 
				-(($numOfSolutions * ($wordFreq.freq $thinFactor) / $totBasis) - count($itemOrTag)) / abs(($numOfSolutions * ($wordFreq.freq $thinFactor) / $totBasis) - count($itemOrTag))
				as result, $wordFreq.freq, count(distinct(fname))
				from $bwMYSQLusertable.$dbname, $wordFreq 
				where $concatWord = $basisWordOrTag
				and $rangeString
				$tagRegexp
				and $wordFreq.freq >= $params{totfreq}
				group by $itemOrTag
				$having
				order by result $descAsc $limitString";
		} elsif ($params{statType}== 3) {
			$sqlQuery="select $itemOrTag, count($itemOrTag) as sum, 
				log((1 / $windowSize) * ((count($itemOrTag) * $totBasis) / ($wordFreq.freq $thinFactor * $numOfSolutions))) * log(count($itemOrTag)) 
				/ (log(2) * log(2))
				as result, $wordFreq.freq, count(distinct(fname))
				from $bwMYSQLusertable.$dbname, $wordFreq 
				where $concatWord = $basisWordOrTag
				and $rangeString
				$tagRegexp
				and $wordFreq.freq >= $params{totfreq}
				group by $itemOrTag
				$having
				order by result desc $limitString";
		} elsif ($params{statType} == 5) {
			$sqlQuery="select $itemOrTag, count($itemOrTag) as sum,
				count($itemOrTag) /
				(($wordFreq.freq $thinFactor / ($totBasis - $numOfSolutions) * $numOfSolutions * $windowSize))
				as result, $wordFreq.freq, count(distinct(fname))
				from $bwMYSQLusertable.$dbname, $wordFreq
				where $concatWord = $basisWordOrTag
				and $rangeString
				$tagRegexp
				and $wordFreq.freq >= $params{totfreq}
				group by $itemOrTag
				$having
				order by result desc $limitString";
		} elsif ($params{statType} == 6) {
			$sqlQuery="select $itemOrTag, count($itemOrTag) as sum,
				(count($itemOrTag) - (($wordFreq.freq $thinFactor / ($totBasis - $numOfSolutions) * $numOfSolutions * $windowSize))) /
				SQRT((($wordFreq.freq $thinFactor / ($totBasis - $numOfSolutions)) * $numOfSolutions * $windowSize) * 
				(1 - ($wordFreq.freq $thinFactor / ($totBasis - $numOfSolutions))))
				as result, $wordFreq.freq, count(distinct(fname))
				from $bwMYSQLusertable.$dbname, $wordFreq
				where $concatWord = $basisWordOrTag
				and $rangeString
				$tagRegexp
				and $wordFreq.freq >= $params{totfreq}
				group by $itemOrTag
				$having
				order by result desc $limitString";		
		
		} elsif ($params{statType} == 7) {

			$sqlQuery="select $itemOrTag, count($itemOrTag) as sum,
				log((1 / $windowSize) * ((count($itemOrTag) * count($itemOrTag) * count($itemOrTag) * $totBasis) / ($wordFreq.freq $thinFactor * $numOfSolutions))) / log(2)
				as result, $wordFreq.freq, count(distinct(fname))
				from $bwMYSQLusertable.$dbname, $wordFreq 
				where $concatWord = $basisWordOrTag
				and $rangeString
				$tagRegexp
				and $wordFreq.freq >= $params{totfreq}
				group by $itemOrTag
				$having
				order by result desc $limitString";

		}
		#print "\nSTARTMYSQLXX958\n";
		$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
		$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
		$resArrayResult=$sth->fetchall_arrayref or bark("Can't fetch $sqlQuery: " . $sth::errstr);
		for $k ( 0 .. ($#{$resArrayResult}) ) {
			$theWord=$resArrayResult->[$k][0];
			$theFrequency=$resArrayResult->[$k][1];
			$theColValue=$resArrayResult->[$k][2];
			$theOccurValue=$resArrayResult->[$k][3];
			$numOfFiles=$resArrayResult->[$k][4];
									
			$indicator=$k + 1;

			if ($theColValue) {
				print "$indicator\t$theWord\t$theOccurValue\t$theFrequency\t$numOfFiles\t$theColValue$crlf";
			} else {
				print "$indicator\t$theWord\t$theOccurValue\t$theFrequency\t$numOfFiles\tn/a$crlf";
			}

		}		
	} else {
		print "------------------------------------------------------------------------------$crlf";
		print "No.\tWord\tn\tn coll.\tn texts$crlf";
		print "------------------------------------------------------------------------------$crlf";

		$sqlQuery="select $itemOrTag, count($itemOrTag) as sum, $wordFreq.freq, count(distinct(fname))
			from $bwMYSQLusertable.$dbname, $wordFreq 
			where $concatWord = $basisWordOrTag
			and $rangeString
			$tagRegexp
			and $wordFreq.freq >= $params{totfreq}
			group by $itemOrTag
			$having
			order by sum desc $limitString";
		$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
		$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
		$resArrayResult=$sth->fetchall_arrayref or bark("Can't fetch $sqlQuery: " . $sth::errstr);
		for $k ( 0 .. ($#{$resArrayResult}) ) {
			$theWord=$resArrayResult->[$k][0];
			$theFrequency=$resArrayResult->[$k][1];
			$theOccurValue=$resArrayResult->[$k][2];
			$numOfFiles=$resArrayResult->[$k][3];
			$indicator=$k + 1;
			
			print "$indicator\t$theWord\t$theOccurValue\t$theFrequency\t$numOfFiles$crlf";
		}
	}
	print "------------------------------------------------------------------------------$crlf";
	
} else {
	# user selected word information

	if ($params{coll} == 2) {
		$wordClean = $wordClean . "_" . $params{lemmaType} unless ($wordClean=~m/_(ADJ|ADV|ART|CONJ|INTERJ|PREP|PRON|SUBST|VERB|UNC)/);
	}

	$searchWord=$userHandle->quote($wordClean);

	# calculate collocation value for selected word (based on the window sisze of the previous collocation list)
	$statTypeName[0]="Mutual information";
	$statTypeName[1]="Log-likelihood";
	$statTypeName[2]="Log-log";
	$statTypeName[3]="Observed/expected";
	$statTypeName[4]="Z-score";
	$statTypeName[5]="MI3";


	$sqlQuery="select count($itemOrTag) as sum,
		(log(count($itemOrTag)) - log($wordFreq.freq * $windowSize * $numOfSolutions / $totBasis))
		/ log(2) as result, $wordFreq.freq, count(distinct(fname))
		from $bwMYSQLusertable.$dbname, $wordFreq 
		where $concatWord = $basisWordOrTag
		and $rangeString
		$tagRegexp
		and $itemOrTag = $searchWord 
		group by $itemOrTag";


	$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	@rowArray=$sth->fetchrow_array;
	
	$theFrequency=$rowArray[0];
	$theColValue[0]=$rowArray[1];
	$theOccurValue=$rowArray[2];
	$numOfFiles=$rowArray[3];
	
	$theFrequency="0" if (!$theFrequency);
	$numOfFiles="0" if (!$numOfFiles);
	$theColValue[0] = "n/a" if (!$theColValue[0]);
	
	$sqlQuery="select count($itemOrTag) as sum,
		2 * (count($itemOrTag) * log(count($itemOrTag))
		+ ($numOfSolutions - count($itemOrTag)) * log(($numOfSolutions - count($itemOrTag))) 
		+ (($wordFreq.freq $thinFactor) - count($itemOrTag)) * log((($wordFreq.freq $thinFactor) - count($itemOrTag))) 
		+ ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)) 
		* log(($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)))
		- (count($itemOrTag) + ($numOfSolutions - count($itemOrTag))) 
		* log(count($itemOrTag) + ($numOfSolutions - count($itemOrTag)))
		- (count($itemOrTag) + (($wordFreq.freq $thinFactor) - count($itemOrTag))) 
		* log(count($itemOrTag) + (($wordFreq.freq $thinFactor) - count($itemOrTag)))
		- (($numOfSolutions - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag))) 
		* log(($numOfSolutions - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)))
		- ((($wordFreq.freq $thinFactor) - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag))) 
		* log((($wordFreq.freq $thinFactor) - count($itemOrTag)) + ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag)))
		+ (count($itemOrTag) + ($numOfSolutions - count($itemOrTag)) + (($wordFreq.freq $thinFactor) - count($itemOrTag))
		+ ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag))) * log(count($itemOrTag) 
		+ ($numOfSolutions - count($itemOrTag)) + (($wordFreq.freq $thinFactor) - count($itemOrTag)) 
		+ ($totBasis - $numOfSolutions - ($wordFreq.freq $thinFactor) + count($itemOrTag))))
		as result, $wordFreq.freq, count(distinct(fname))
		from $bwMYSQLusertable.$dbname, $wordFreq 
		where $concatWord = $basisWordOrTag
		and $rangeString
		and $itemOrTag = $searchWord
		$tagRegexp 
		group by $itemOrTag";
	
	$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	@rowArray=$sth->fetchrow_array;
	
	$theColValue[1]=$rowArray[1];		
	$theColValue[1] = "n/a" if (!$theColValue[1]);
	
	$sqlQuery="select count($itemOrTag) as sum, 
			log((1 / $windowSize) * ((count($itemOrTag) * $totBasis) / ($wordFreq.freq $thinFactor * $numOfSolutions))) * log(count($itemOrTag)) 
			as result, $wordFreq.freq, count(distinct(fname))
			from $bwMYSQLusertable.$dbname, $wordFreq 
			where $concatWord = $basisWordOrTag
			and $rangeString
			$tagRegexp
			and $itemOrTag = $searchWord
			group by $itemOrTag";
			
	$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	@rowArray=$sth->fetchrow_array;
	
	$theColValue[2]=$rowArray[1];
	$theColValue[2] = "n/a" if (!$theColValue[2]);
	
# 	O/E code
	$sqlQuery="select count($itemOrTag) as sum,
			count($itemOrTag) /
			(($wordFreq.freq $thinFactor / ($totBasis - $numOfSolutions) * $numOfSolutions * $windowSize))
			as result, $wordFreq.freq, count(distinct(fname))
			from $bwMYSQLusertable.$dbname, $wordFreq
			where $concatWord = $basisWordOrTag
			and $rangeString
			$tagRegexp
			and $itemOrTag = $searchWord
			group by $itemOrTag";

	$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	@rowArray=$sth->fetchrow_array;
	
	$theColValue[3]=$rowArray[1];
	$theColValue[3] = "n/a" if (!$theColValue[3]);

	$sqlQuery="select count($itemOrTag) as sum,
			(count($itemOrTag) - (($wordFreq.freq  $thinFactor / ($totBasis - $numOfSolutions) * $numOfSolutions * $windowSize))) /
			SQRT((($wordFreq.freq  $thinFactor / ($totBasis - $numOfSolutions)) * $numOfSolutions * $windowSize) * 
			(1 - ($wordFreq.freq  $thinFactor / ($totBasis - $numOfSolutions))))
			as result, $wordFreq.freq, count(distinct(fname))
			from $bwMYSQLusertable.$dbname, $wordFreq
			where $concatWord = $basisWordOrTag
			and $rangeString
			$tagRegexp
			and $itemOrTag = $searchWord
			group by $itemOrTag";

	$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	@rowArray=$sth->fetchrow_array;
	
	$theColValue[4]=$rowArray[1];
	$theColValue[4] = "n/a" if (!$theColValue[4]);

	$sqlQuery="select count($itemOrTag) as sum,
			log((1 / $windowSize) * ((count($itemOrTag) * count($itemOrTag) * count($itemOrTag) * $totBasis) / ($wordFreq.freq $thinFactor * $numOfSolutions))) / log(2)
			as result, $wordFreq.freq, count(distinct(fname))
			from $bwMYSQLusertable.$dbname, $wordFreq
			where $concatWord = $basisWordOrTag
			and $rangeString
			$tagRegexp
			and $itemOrTag = $searchWord
			group by $itemOrTag";

	$sth= $bncHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $sth::errstr);
	$sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
	@rowArray=$sth->fetchrow_array;
	
	$theColValue[5]=$rowArray[1];
	$theColValue[5] = "n/a" if (!$theColValue[5]);

	
	unless (($params{tag} eq "all") || ($params{coll})) {
		$tagName=" with tag restriction <I>$tag</I>";
		$tagName=" with tag restriction <I>any verb</I>" if ($tagClean =~m/\AV\[/);
		$tagName=" with tag restriction <I>any noun</I>" if ($tagClean =~m/\AN\[/);
		$tagName=" with tag restriction <I>any conjunction</I>" if ($tagClean =~m/\ACJ\[/);
		$tagName=" with tag restriction <I>any adjective</I>" if ($tagClean =~m/\AAJ\[/);
		$tagName=" with tag restriction <I>any adverb</I>" if ($tagClean =~m/\AAV\[/);
		$tagName=" with tag restriction <I>any pronoun</I>" if ($tagClean =~m/\APN\[/);
	} else {
		$tagName="";
	}
	
	$tagName=~s/<\/?I>/\"/g;
	
	$countTot=0;
	for ($i = -($params{totrange}); $i <= $params{totrange}; $i++) {
		next if ($i == 0);
		$sqlQuery = "SELECT count($itemOrTag), count(distinct(fname)) FROM $dbname WHERE $itemOrTag=$searchWord AND dist=$i $tagRegexp";
		$sth= $userHandle->prepare($sqlQuery) or bark("Can't prepare $sqlQuery: " . $userHandle::errstr);
		$res = $sth->execute or bark("Can't execute $sqlQuery: " . $sth::errstr);
		
		@rowArray=$sth->fetchrow_array;
		$frequency{$i}=$rowArray[0];
		$fileNums{$i}=$rowArray[1];
	
		$countTot += $frequency{$i} if ($frequency{$i});
	}	
	
	$theShowWord=$wordClean;
	$theShowWord=&output2($theShowWord);
	$theShowWord=~s/_/-/ if ($params{coll} == 1);
	
	if ($countTot) {



		print "${crlf}$displayWord information for the node \"$theDataShow\" and \"$theShowWord\" ($theOccurValue occurrences in whole BNC)${tagName}$crlf";
		print "------------------------------------------------------------------------------$crlf";
		print "Type of Statistics\tValue (for window size $params{minus} to $params{plus})$crlf";
		print "------------------------------------------------------------------------------$crlf";
		for ($i = 0; $i <= 5; $i++) {
			print "$statTypeName[$i]\t$theColValue[$i]$crlf";
			
		}
		print "------------------------------------------------------------------------------$crlf$crlf";
		print "Within the window $params{minus} to $params{plus}, \"$theShowWord\" occurs $theFrequency times in $numOfFiles different files.$crlf";
		print "------------------------------------------------------------------------------$crlf";
		print "Distance\tNo. of Occurrences\tIn No. of Files\tPercent$crlf";
		print "------------------------------------------------------------------------------$crlf";
		
		for ($i = -($params{totrange}); $i <= $params{totrange}; $i++) {
			next if ($i == 0);
			$frequency = $frequency{$i};
			$numFiles = $fileNums{$i};
			if (!$frequency) {
				$theLink="$i";
				$frequency="0";
				$percent = "0";
			}
			
			$percent = int((($frequency / $countTot) * 10000) + 0.5)/ 100 if ($countTot);
			
			print "$i\t$frequency\t$numFiles\t$percent$crlf";
		}
		
		print "------------------------------------------------------------------------------$crlf";
		print "Total\t$countTot\t\t100%$crlf";
		
		undef %frequency;
	} else {
		print "$wordClean $tagName does not collocate with \"$theDataShow\" within a window of $minusTotal and $params{totrange}.$crlf";
	}
}


exit(0);
