#
# BNCweb: A user-friendly interface to the British National Corpus - Version 4.0
# Copyright (C) 2005-7 Hoffmann/Evert/Lehmann
#
# Updates and information available at http://www.bncweb.info
#
# This file is part of BNCweb.
# 
# BNCweb is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
# 
# BNCweb is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
# based on BNCweb Version 2.0:
#  1996/2004 Lehmann/Hoffmann/Schneider
#

#Module Declarations
package bncConfigXML;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw($bwCGIalias $bwHTMLalias $bwServer $bwWebServer $bwCorpusPath $bwMYSQLhost $bwMysqlUser $bwMysqlPwd $bwMYSQLusertable 
			$bwMYSQLcategorizetable $bwMYSQLtable $null $bwMysqlPort $bwConcurrentProcesses 
			$bwSuperuser $bwTempPath $bwSavePath $bwCopyright $bwDefaultCollocation $bwDefaultDist $bwDefaultSort
			$bwHeaderLength $bwJavaScript $bwMySQLTempPath $bwFileSize $bwMaxMySQLSize $bwCorpus $bwCorpusText $bwCorpusSpeaker $bwMYSQLfrequency $bwMaxFreqlistMySQL);

###########################################################################
#                                                                         #
# SECTION 1: THIS WILL REQUIRE CHANGES FOR THE INSTALLATION OF  BNCweb.   #
#                                                                         #
###########################################################################
# GENERAL SETTINGS
#
# alias for the cgi-bin directory that contains all BNCweb files with the suffix .pl
$bwCGIalias = 'cgi-binbncXML';
# alias for the html directory that contains all BNCweb files with the suffix .html and .gif
$bwHTMLalias = 'bncwebXML';
# server where BNCweb scripts run (without "http://") - MySQL will only accept connections from this host
$bwServer = 'localhost';
#
# server address to compile URL (including "http://" or "https://")
$bwWebServer = "http://localhost";
#
# temp path - this needs to be an existing directory whose permissions are set to be world readable and writable by the Web server.
# You may need to give the full path here...
$bwTempPath = 'CQP-tempXML';
# Separate save path currently not yet implemented
#$bwSavePath = 'CQP-saveXML';
# 
$bwMySQLTempPath = $bwTempPath; # MySQL and BNCweb are running on same server
#
# name of CQP corpus
$bwCorpus = "BNC-XML";
# name of CQP text frequency table
$bwCorpusText = "BNC-XML_FREQ_TEXT";
# name of CQP speaker frequency table
$bwCorpusSpeaker = "BNC-XML_FREQ_SPEAKER";

# #####################################################
# MySQL settings
#
# address of the machine running MySQL. 
# set to 'localhost' if BNCweb is installed on a stand-alone computer
$bwMYSQLhost = 'localhost';
#
# name of the fatabase that contains most MySQL tables included in the distribution
$bwMYSQLtable = 'bncweb_bncData';
#
# name of the database that contains all temporary MySQL tables
#
$bwMYSQLusertable = 'bncweb_bncUserData';
#
# name of the database that contains categorized query results
#
$bwMYSQLcategorizetable = 'bncweb_bncUserCategorize';
#
# name of the database that contains frequency tables
#
$bwMYSQLfrequency = 'bncweb_freq_tables';
#
# the port on which MySQL runs
$bwMysqlPort = '3306';
# the name of MySQL user
$bwMysqlUser = 'username';
# the MySQL user password
$bwMysqlPwd = 'password';
#

#############################
#                           #
# SECTION 2: OTHER SETTINGS #
#                           #
#############################
#
# Administrator name(s)
#
# username(s) of the superuser(s)
# superusers can see the query history of all users; they can also see and delete all subcorpora
# separate individual users by a vertical slash (without any whitespaces)
$bwSuperuser = 'superuser1|superuser2|superuser3';
#
################################
# Restrictions relating to MySQL-based features
#
# Setting upper limits is useful when BNCweb is run on a server with many users.
# Limits for individual users can be set in BNCweb via the admin features ($bwSuperuser users only!)
#
# maximum number of query hits for the Sort feature
# default:
$bwDefaultSort = 250000;
#
# maximum number of query hits for the Collocation feature (this is the most disk-space intensive feature)
# default:
$bwDefaultCollocation = 250000;
#
# maximum number of query hits for the Distribution and Subcorpus features
# default:
$bwDefaultDist = 1000000;
#
# maximum number of concurrent collocation and sort processes
$bwConcurrentProcesses = 5;
#
#
###############################
#Cache settings
#
# Total size (in bytes) of temp files (for CQP only!) before cached queries are deleted
# Default is 3 GB
$bwFileSize = 3221225472;

# Total size (in bytes) of MySQL temp files before cached tables are deleted
# Default is 3 GB
$bwMaxMySQLSize = 3221225472;
#
# Total size (in bytes) of MySQL frequency lists files before cached tables are deleted
# Default is 3 GB
$bwMaxFreqlistMySQL = 3221225472;
#
#


1;
