
/*  A Bison parser, made from parser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	ID	257
#define	QID	258
#define	LABEL	259
#define	STRING	260
#define	FLAG	261
#define	TAGSTART	262
#define	TAGEND	263
#define	VARIABLE	264
#define	IPAddress	265
#define	IPSubnet	266
#define	INTEGER	267
#define	FLOAT	268
#define	FIELD	269
#define	FIELDLABEL	270
#define	ANCHORTAG	271
#define	ANCHORENDTAG	272
#define	SEARCH_STRATEGY	273
#define	TAB_SYM	274
#define	CAT_SYM	275
#define	DEFINE_SYM	276
#define	DIFF_SYM	277
#define	DISCARD_SYM	278
#define	EXPAND_SYM	279
#define	EXIT_SYM	280
#define	FLAT_SYM	281
#define	INTER_SYM	282
#define	JOIN_SYM	283
#define	SUBSET_SYM	284
#define	LEFT_SYM	285
#define	RIGHT_SYM	286
#define	SAVE_SYM	287
#define	SCATTER_SYM	288
#define	SHOW_SYM	289
#define	CD_SYM	290
#define	TO_SYM	291
#define	WITHIN_SYM	292
#define	SET_SYM	293
#define	EXEC_SYM	294
#define	CUT_SYM	295
#define	OCCURS_SYM	296
#define	INFO_SYM	297
#define	GROUP_SYM	298
#define	WHERE_SYM	299
#define	ESCAPE_SYM	300
#define	MEET_SYM	301
#define	UNION_SYM	302
#define	MU_SYM	303
#define	SORT_SYM	304
#define	COUNT_SYM	305
#define	ASC_SYM	306
#define	DESC_SYM	307
#define	REVERSE_SYM	308
#define	BY_SYM	309
#define	FOREACH_SYM	310
#define	ON_SYM	311
#define	YES_SYM	312
#define	OFF_SYM	313
#define	NO_SYM	314
#define	SLEEP_SYM	315
#define	REDUCE_SYM	316
#define	MAXIMAL_SYM	317
#define	WITH_SYM	318
#define	WITHOUT_SYM	319
#define	DELETE_SYM	320
#define	SIZE_SYM	321
#define	DUMP_SYM	322
#define	UNDUMP_SYM	323
#define	TABULATE_SYM	324
#define	NOT_SYM	325
#define	CONTAINS_SYM	326
#define	MATCHES_SYM	327
#define	GCDEL	328
#define	APPEND	329
#define	LET	330
#define	GET	331
#define	NEQ	332
#define	IMPLIES	333
#define	RE_PAREN	334
#define	EOL_SYM	335
#define	ELLIPSIS	336
#define	MATCHALL	337
#define	LCSTART	338
#define	LCEND	339
#define	LCMATCHALL	340
#define	PLUSEQ	341
#define	MINUSEQ	342
#define	UNLOCK_SYM	343
#define	USER_SYM	344
#define	HOST_SYM	345
#define	UNDEFINED_MACRO	346
#define	MACRO_SYM	347
#define	RANDOMIZE_SYM	348
#define	FROM_SYM	349
#define	INCLUSIVE_SYM	350
#define	EXCLUSIVE_SYM	351
#define	NULL_SYM	352

#line 1 "parser.y"

/* 
 *  IMS Open Corpus Workbench (CWB)
 *  Copyright (C) 1993-2006 by IMS, University of Stuttgart
 *  Copyright (C) 2007-     by the respective contributers (see file AUTHORS)
 * 
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2, or (at your option) any later
 *  version.
 * 
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
 *  Public License for more details (in the file "COPYING", or available via
 *  WWW at http://www.gnu.org/copyleft/gpl.html).
 */


#include <sys/time.h>
#include <sys/resource.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <assert.h>
#include <stdarg.h>
#include <stdlib.h>

#include "../cl/globals.h"
#include "../cl/special-chars.h"
#include "../cl/attributes.h"
#include "../cl/macros.h"

#include "cqp.h"
#include "options.h"
#include "ranges.h"
#include "symtab.h"
#include "treemacros.h"
#include "tree.h"
#include "eval.h"
#include "corpmanag.h"
#include "regex2dfa.h"
#include "builtins.h"
#include "groups.h"
#include "targets.h"
#include "attlist.h"
#include "concordance.h"
#include "output.h"
#include "print-modes.h"
#include "variables.h"

#include "parse_actions.h"

/* CQPserver user authentication */
#include "../CQi/auth.h"

/* macro expansion */
#include "macro.h"
 


/* ============================================================ YACC IF */

extern int yychar;

extern int yylex(void);

void yyerror (char *s)
{
  cqpmessage(Error, "CQP Syntax Error: %s\n\t%s <--", s, QueryBuffer);
  generate_code = 0;
}

void warn_query_lock_violation(void) {
  if (which_app != cqpserver)
    fprintf(stderr, "WARNING: query lock violation attempted\n");
  query_lock_violation++;	/* this is for the CQPserver */
}

/* ============================================================ */

#define SYNCHRONIZE

void
synchronize(void)
{
#if defined(SYNCHRONIZE)
  int macro_status;

  /* delete macro buffers & disable macro expansion while sync'ing */
  delete_macro_buffers(1); /* print stack trace on STDERR */
  macro_status = enable_macros;
  enable_macros = 0;

  if (cqp_input_string != NULL) {
    fprintf(stderr, "Synchronizing to end of line ... \n");
    while (!(yychar <= 0))
      yychar = yylex();
  }
  else {
    fprintf(stderr, "Synchronizing until next ';'...\n");
    while (!(yychar <= 0 || yychar == ';'))
      yychar = yylex();
  }

  enable_macros = macro_status;	/* reset enable_macros to previous value */
#endif
}

#define YYERROR_VERBOSE


#line 114 "parser.y"
typedef union {
  Evaltree           evalt;
  Constrainttree     boolt;
  enum b_ops         boolo;
  int                ival;
  double             fval;
  int                index;
  char              *strval;
  CorpusList        *cl;

  struct {
    int a, b;
  } intpair;

  Context            context;
  ActualParamList   *apl;

  enum ctxtdir       direction;

  struct Redir       redir;

  struct InputRedir  in_redir;

  struct {
    int ok;
    int ival;
    char *cval;
  }                  varval;

  struct {
    FieldType field;
    int inclusive;
  }                  base;

  struct {
    char *variableValue;
    char operator;
  }                  varsetting;

  struct {
    int mindist;
    int maxdist;
  }                  Distance;

  struct {
    FieldType anchor;
    int offset;
  }		     Anchor;

  struct {
    FieldType anchor1;
    int offset1;
    FieldType anchor2;
    int offset2;
  }		     AnchorPair;

  struct {
    char *name;
    int flags;
  }                  AttributeSpecification;

  RangeSetOp         rngsetop;

  SortClause         sortclause;

  FieldType          field;

  SearchStrategy     search_strategy;

  TabulationItem     tabulation_item;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		492
#define	YYFLAG		-32768
#define	YYNTBASE	121

#define YYTRANSLATE(x) ((unsigned)(x) <= 352 ? yytranslate[x] : 257)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   103,     2,     2,     2,   110,   102,     2,   112,
   113,   100,   101,   109,   108,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   119,   104,   107,
   105,   106,   111,   116,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   117,     2,   118,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   114,    99,   115,   120,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     6,     7,     8,    12,    13,    18,    21,
    22,    26,    27,    30,    32,    34,    38,    41,    43,    45,
    46,    49,    51,    53,    55,    57,    59,    61,    63,    65,
    67,    69,    71,    73,    75,    77,    79,    81,    83,    85,
    87,    89,    91,    93,    96,    98,   102,   110,   114,   118,
   120,   121,   124,   127,   129,   130,   133,   135,   138,   141,
   144,   147,   149,   152,   155,   159,   161,   163,   165,   167,
   169,   170,   177,   180,   183,   185,   188,   192,   197,   202,
   207,   210,   213,   216,   219,   223,   226,   228,   233,   238,
   239,   251,   255,   256,   258,   260,   261,   263,   265,   267,
   269,   271,   273,   275,   278,   281,   284,   286,   297,   308,
   316,   318,   319,   320,   326,   327,   337,   339,   343,   346,
   348,   352,   355,   356,   360,   365,   371,   373,   374,   381,
   384,   389,   390,   392,   394,   395,   397,   398,   404,   410,
   414,   419,   421,   422,   427,   432,   436,   438,   442,   445,
   449,   452,   456,   464,   470,   472,   473,   474,   477,   481,
   483,   487,   489,   491,   493,   498,   503,   505,   506,   507,
   508,   509,   516,   520,   522,   525,   527,   530,   533,   536,
   539,   541,   545,   547,   549,   551,   555,   561,   563,   565,
   568,   574,   576,   578,   580,   582,   583,   587,   589,   590,
   592,   593,   595,   597,   600,   602,   606,   608,   612,   614,
   616,   617,   620,   621,   622,   629,   630,   632,   633,   637,
   638,   641,   642,   644,   645,   647,   648,   650,   651,   656,
   657,   659,   661,   662,   665,   667,   669,   670,   672,   676,
   680,   684,   688,   691,   693,   697,   702,   704,   707,   710,
   712,   713,   715,   718,   720,   723,   725,   727,   729,   732,
   737,   739,   741,   743,   745,   747,   749,   751,   753,   755,
   760,   762,   766,   768,   770,   772,   774,   776,   783,   786,
   788,   789,   795,   799,   802,   806,   807,   811,   817,   822,
   823,   824,   830,   833,   836,   839,   843,   844,   847,   848,
   856,   864,   869,   871,   872,   875,   879,   886,   889,   891,
   893,   896,   897,   899,   900,   902,   903,   905,   906,   908,
   909,   911,   912,   914
};

static const short yyrhs[] = {    -1,
   122,   123,     0,   104,     0,     0,     0,   124,   128,   104,
     0,     0,    89,    13,   125,   104,     0,   133,   104,     0,
     0,   126,   132,   104,     0,     0,   127,    26,     0,     1,
     0,   129,     0,     3,   105,   129,     0,   130,   217,     0,
   221,     0,   143,     0,     0,   131,   184,     0,   140,     0,
   134,     0,   135,     0,   147,     0,   176,     0,   174,     0,
   152,     0,   150,     0,   149,     0,   157,     0,   158,     0,
   159,     0,   168,     0,   178,     0,   179,     0,   180,     0,
   181,     0,   161,     0,   241,     0,   245,     0,   247,     0,
   249,     0,    46,   250,     0,    81,     0,    21,   220,   136,
     0,    21,   220,   253,    13,   254,    13,   136,     0,    21,
   143,   136,     0,    33,   220,   136,     0,   137,     0,     0,
   106,     6,     0,    75,     6,     0,   139,     0,     0,   107,
     6,     0,    35,     0,    35,     3,     0,    35,   141,     0,
    35,    36,     0,   141,   142,     0,   142,     0,   101,     3,
     0,   108,     3,     0,   144,   221,   221,     0,   145,     0,
    29,     0,    48,     0,    28,     0,    23,     0,     0,    30,
   220,    45,    16,   146,   205,     0,    24,   148,     0,   148,
   221,     0,   221,     0,    35,    10,     0,    22,    10,   151,
     0,    22,    10,    87,    10,     0,    22,    10,    88,    10,
     0,    22,    10,   105,    10,     0,   107,     6,     0,   105,
     6,     0,    87,     6,     0,    88,     6,     0,    39,     3,
   156,     0,    39,     3,     0,    39,     0,    39,   221,    15,
    15,     0,    39,   221,    15,    98,     0,     0,    39,   221,
    15,    19,   153,   205,    38,   218,   214,     3,   154,     0,
    95,    15,   155,     0,     0,    96,     0,    97,     0,     0,
    13,     0,     6,     0,     3,     0,    57,     0,    58,     0,
    59,     0,    60,     0,    13,     3,     0,    40,     6,     0,
    43,   221,     0,    43,     0,    44,   221,   256,     3,    55,
   256,     3,   213,   160,   136,     0,    44,   221,   256,     3,
    56,   256,     3,   213,   160,   136,     0,    44,   221,   256,
     3,   213,   160,   136,     0,    25,     0,     0,     0,    70,
   221,   162,   164,   136,     0,     0,    70,   221,   163,   253,
    13,   254,    13,   164,   136,     0,   165,     0,   164,   109,
   165,     0,   166,   167,     0,   256,     0,   256,   255,   256,
     0,     3,   207,     0,     0,    50,   220,   169,     0,    50,
   220,    94,   215,     0,    51,   220,   170,   213,   136,     0,
   170,     0,     0,    55,     3,   207,   171,   172,   173,     0,
   252,   256,     0,   252,   256,   255,   256,     0,     0,    52,
     0,    53,     0,     0,    54,     0,     0,    62,   220,    37,
    13,   175,     0,    62,   220,    37,    63,    73,     0,    41,
   220,    13,     0,    41,   220,    13,    13,     0,   110,     0,
     0,    66,   220,    64,    15,     0,    66,   220,    65,    15,
     0,    66,   220,   177,     0,    13,     0,    13,    82,    13,
     0,    61,    13,     0,    67,   221,   251,     0,    67,    10,
     0,    68,   221,   136,     0,    68,   221,   253,    13,   254,
    13,   136,     0,    69,     3,   183,   182,   138,     0,    52,
     0,     0,     0,    64,    15,     0,    64,    15,    15,     0,
   185,     0,   185,    50,   169,     0,   186,     0,   187,     0,
   237,     0,   189,   209,   213,   188,     0,    49,   233,   188,
   213,     0,   103,     0,     0,     0,     0,     0,   190,   193,
   191,   208,   192,   212,     0,   193,    99,   194,     0,   194,
     0,   194,   195,     0,   195,     0,   196,   197,     0,   196,
   100,     0,   196,   101,     0,   196,   111,     0,   196,     0,
   112,   193,   113,     0,   201,     0,   199,     0,   198,     0,
   114,    13,   115,     0,   114,    13,   109,   216,   115,     0,
    17,     0,    18,     0,     8,   106,     0,     8,   200,     6,
   207,   106,     0,     9,     0,   224,     0,    78,     0,   105,
     0,     0,   202,   203,   204,     0,   116,     0,     0,     5,
     0,     0,   205,     0,   206,     0,     6,   207,     0,    10,
     0,   117,   222,   118,     0,    83,     0,    84,   222,    85,
     0,    86,     0,     7,     0,     0,    74,   222,     0,     0,
     0,   209,   119,     3,   210,   211,   189,     0,     0,   103,
     0,     0,    38,   218,   219,     0,     0,    41,    13,     0,
     0,    13,     0,     0,    13,     0,     0,    13,     0,     0,
    25,   218,    37,   219,     0,     0,    31,     0,    32,     0,
     0,   214,     3,     0,    13,     0,   221,     0,     0,     3,
     0,   222,    79,   222,     0,   222,    99,   222,     0,   222,
   102,   222,     0,   112,   222,   113,     0,   103,   222,     0,
   223,     0,   226,   228,   227,     0,   226,   224,     6,   207,
     0,   226,     0,   225,    72,     0,   225,    73,     0,    71,
     0,     0,   232,     0,   120,   232,     0,     3,     0,   120,
     3,     0,    15,     0,   229,     0,   226,     0,     6,   207,
     0,    80,    10,   113,   207,     0,    10,     0,    13,     0,
    14,     0,   107,     0,   106,     0,   105,     0,    78,     0,
    76,     0,    77,     0,     3,   112,   230,   113,     0,   231,
     0,   230,   109,   231,     0,   227,     0,     4,     0,   234,
     0,   236,     0,   204,     0,   112,    47,   233,   233,   235,
   113,     0,    13,    13,     0,     3,     0,     0,   112,    48,
   233,   233,   113,     0,    20,   238,   212,     0,   201,   239,
     0,   239,   240,   201,     0,     0,   114,    13,   115,     0,
   114,    13,   109,   216,   115,     0,   114,   109,    13,   115,
     0,     0,     0,    90,     3,     6,   242,   243,     0,    91,
    11,     0,    91,    12,     0,    91,   100,     0,   112,   244,
   113,     0,     0,   244,     3,     0,     0,   246,    93,     3,
   112,    13,   113,   248,     0,   246,    93,     3,   112,     6,
   113,   248,     0,   246,    93,   107,     6,     0,    22,     0,
     0,    35,    93,     0,    35,    93,     3,     0,    35,    93,
     3,   112,    13,   113,     0,   248,     6,     0,     6,     0,
    94,     0,    94,    13,     0,     0,    15,     0,     0,    57,
     0,     0,    95,     0,     0,    37,     0,     0,    82,     0,
     0,    15,     0,    15,   117,    13,   118,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   352,   353,   357,   358,   361,   362,   363,   374,   374,   375,
   376,   377,   378,   379,   388,   389,   393,   397,   398,   399,
   400,   403,   404,   405,   406,   407,   408,   409,   410,   411,
   412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
   422,   423,   424,   425,   430,   433,   436,   439,   446,   450,
   451,   458,   463,   471,   472,   478,   484,   487,   501,   503,
   507,   510,   513,   515,   518,   519,   522,   523,   524,   525,
   528,   536,   547,   550,   553,   558,   563,   571,   577,   583,
   594,   596,   597,   598,   601,   624,   632,   635,   636,   637,
   646,   654,   659,   665,   666,   667,   670,   674,   678,   683,
   684,   685,   686,   687,   694,   697,   698,   701,   707,   713,
   722,   723,   728,   730,   732,   734,   738,   740,   744,   756,
   758,   763,   765,   775,   787,   798,   809,   811,   814,   832,
   833,   836,   841,   842,   843,   846,   847,   852,   856,   860,
   864,   870,   871,   874,   880,   886,   894,   895,   900,   904,
   905,   908,   911,   915,   919,   920,   923,   925,   930,   941,
   942,   952,   953,   954,   957,   962,   966,   967,   970,   971,
   973,   974,   977,   979,   982,   984,   987,   995,  1000,  1005,
  1010,  1013,  1014,  1019,  1024,  1031,  1036,  1045,  1046,  1049,
  1050,  1052,  1055,  1056,  1057,  1058,  1061,  1067,  1068,  1071,
  1072,  1075,  1076,  1079,  1080,  1092,  1093,  1101,  1102,  1110,
  1141,  1144,  1145,  1148,  1152,  1155,  1158,  1159,  1162,  1170,
  1178,  1179,  1182,  1183,  1186,  1187,  1190,  1191,  1194,  1200,
  1207,  1208,  1209,  1212,  1213,  1216,  1217,  1221,  1241,  1242,
  1243,  1244,  1245,  1246,  1249,  1250,  1259,  1262,  1263,  1266,
  1267,  1270,  1271,  1272,  1273,  1274,  1275,  1278,  1279,  1280,
  1284,  1301,  1309,  1319,  1320,  1321,  1322,  1323,  1324,  1327,
  1330,  1332,  1349,  1360,  1363,  1364,  1365,  1373,  1380,  1386,
  1387,  1395,  1401,  1407,  1411,  1415,  1418,  1419,  1421,  1422,
  1427,  1429,  1429,  1430,  1431,  1434,  1435,  1439,  1441,  1445,
  1454,  1464,  1470,  1471,  1475,  1478,  1482,  1491,  1501,  1505,
  1506,  1509,  1514,  1515,  1517,  1518,  1520,  1521,  1523,  1524,
  1526,  1527,  1531,  1532
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ID","QID",
"LABEL","STRING","FLAG","TAGSTART","TAGEND","VARIABLE","IPAddress","IPSubnet",
"INTEGER","FLOAT","FIELD","FIELDLABEL","ANCHORTAG","ANCHORENDTAG","SEARCH_STRATEGY",
"TAB_SYM","CAT_SYM","DEFINE_SYM","DIFF_SYM","DISCARD_SYM","EXPAND_SYM","EXIT_SYM",
"FLAT_SYM","INTER_SYM","JOIN_SYM","SUBSET_SYM","LEFT_SYM","RIGHT_SYM","SAVE_SYM",
"SCATTER_SYM","SHOW_SYM","CD_SYM","TO_SYM","WITHIN_SYM","SET_SYM","EXEC_SYM",
"CUT_SYM","OCCURS_SYM","INFO_SYM","GROUP_SYM","WHERE_SYM","ESCAPE_SYM","MEET_SYM",
"UNION_SYM","MU_SYM","SORT_SYM","COUNT_SYM","ASC_SYM","DESC_SYM","REVERSE_SYM",
"BY_SYM","FOREACH_SYM","ON_SYM","YES_SYM","OFF_SYM","NO_SYM","SLEEP_SYM","REDUCE_SYM",
"MAXIMAL_SYM","WITH_SYM","WITHOUT_SYM","DELETE_SYM","SIZE_SYM","DUMP_SYM","UNDUMP_SYM",
"TABULATE_SYM","NOT_SYM","CONTAINS_SYM","MATCHES_SYM","GCDEL","APPEND","LET",
"GET","NEQ","IMPLIES","RE_PAREN","EOL_SYM","ELLIPSIS","MATCHALL","LCSTART","LCEND",
"LCMATCHALL","PLUSEQ","MINUSEQ","UNLOCK_SYM","USER_SYM","HOST_SYM","UNDEFINED_MACRO",
"MACRO_SYM","RANDOMIZE_SYM","FROM_SYM","INCLUSIVE_SYM","EXCLUSIVE_SYM","NULL_SYM",
"'|'","'*'","'+'","'&'","'!'","';'","'='","'>'","'<'","'-'","','","'%'","'?'",
"'('","')'","'{'","'}'","'@'","'['","']'","':'","'~'","line","@1","command",
"@2","@3","@4","@5","CorpusCommand","UnnamedCorpusCommand","CYCommand","@6",
"InteractiveCommand","EOLCmd","Cat","Saving","OptionalRedir","Redir","OptionalInputRedir",
"InputRedir","Showing","AttributeSelections","AttributeSelection","CorpusSetExpr",
"SetOp","SubsetExpr","@7","Discard","DiscArgs","VarPrintCmd","VarDefCmd","VariableValueSpec",
"OptionSetCmd","@8","OptBase","InclusiveExclusive","VarValue","ExecCmd","InfoCmd",
"GroupCmd","OptExpansion","TabulateCmd","@9","@10","TabulationItems","TabulationItem",
"TabulationRange","OptAttributeSpec","SortCmd","OptionalSortClause","SortClause",
"SortBoundaries","SortDirection","OptReverse","Reduction","OptPercent","Delete",
"LineRange","SleepCmd","SizeCmd","DumpCmd","UndumpCmd","OptAscending","OptWithTargetKeyword",
"Query","AQuery","StandardQuery","MUQuery","OptKeep","SearchPattern","@11","@12",
"@13","RegWordfExpr","RegWordfTerm","RegWordfFactor","RegWordfPower","Repeat",
"AnchorPoint","XMLTag","RegexpOp","NamedWfPattern","OptTargetSign","OptRefId",
"WordformPattern","ExtConstraint","LookaheadConstraint","OptionalFlag","GlobalConstraint",
"AlignmentConstraints","@14","OptNot","SearchSpace","CutStatement","OptNumber",
"OptInteger","OptMaxNumber","ReStructure","OptDirection","Description","OptionalCID",
"CID","BoolExpr","RelExpr","MvalOp","OptionalNot","RelLHS","RelRHS","RelOp",
"FunctionCall","FunctionArgList","SingleArg","LabelReference","MUStatement",
"MeetStatement","MeetContext","UnionStatement","TABQuery","TabPatterns","TabOtherPatterns",
"OptDistance","AuthorizeCmd","@15","OptionalGrants","Grants","Macro","OptDEFINE_SYM",
"ShowMacro","MultiString","RandomizeCmd","OtherCommand","OptionalFIELD","OptON",
"OptFROM","OptTO","OptELLIPSIS","Anchor", NULL
};
#endif

static const short yyr1[] = {     0,
   122,   121,   121,   121,   124,   123,   125,   123,   123,   126,
   123,   127,   123,   123,   128,   128,   129,   130,   130,   131,
   130,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
   132,   132,   132,   132,   133,   134,   134,   134,   135,   136,
   136,   137,   137,   138,   138,   139,   140,   140,   140,   140,
   141,   141,   142,   142,   143,   143,   144,   144,   144,   144,
   146,   145,   147,   148,   148,   149,   150,   150,   150,   150,
   151,   151,   151,   151,   152,   152,   152,   152,   152,   153,
   152,   154,   154,   155,   155,   155,   156,   156,   156,   156,
   156,   156,   156,   156,   157,   158,   158,   159,   159,   159,
   160,   160,   162,   161,   163,   161,   164,   164,   165,   166,
   166,   167,   167,   168,   168,   168,   169,   169,   170,   171,
   171,   171,   172,   172,   172,   173,   173,   174,   174,   174,
   174,   175,   175,   176,   176,   176,   177,   177,   178,   179,
   179,   180,   180,   181,   182,   182,   183,   183,   183,   184,
   184,   185,   185,   185,   186,   187,   188,   188,   190,   191,
   192,   189,   193,   193,   194,   194,   195,   195,   195,   195,
   195,   196,   196,   196,   196,   197,   197,   198,   198,   199,
   199,   199,   200,   200,   200,   200,   201,   202,   202,   203,
   203,   204,   204,   205,   205,   205,   205,   206,   206,   207,
   207,   208,   208,   210,   209,   209,   211,   211,   212,   212,
   213,   213,   214,   214,   215,   215,   216,   216,   217,   217,
   218,   218,   218,   219,   219,   220,   220,   221,   222,   222,
   222,   222,   222,   222,   223,   223,   223,   224,   224,   225,
   225,   226,   226,   226,   226,   226,   226,   227,   227,   227,
   227,   227,   227,   228,   228,   228,   228,   228,   228,   229,
   230,   230,   231,   232,   233,   233,   233,   234,   235,   235,
   235,   236,   237,   238,   239,   239,   240,   240,   240,   240,
   242,   241,   241,   241,   241,   243,   243,   244,   244,   245,
   245,   245,   246,   246,   247,   247,   247,   248,   248,   249,
   249,   250,   251,   251,   252,   252,   253,   253,   254,   254,
   255,   255,   256,   256
};

static const short yyr2[] = {     0,
     0,     2,     1,     0,     0,     3,     0,     4,     2,     0,
     3,     0,     2,     1,     1,     3,     2,     1,     1,     0,
     2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     2,     1,     3,     7,     3,     3,     1,
     0,     2,     2,     1,     0,     2,     1,     2,     2,     2,
     2,     1,     2,     2,     3,     1,     1,     1,     1,     1,
     0,     6,     2,     2,     1,     2,     3,     4,     4,     4,
     2,     2,     2,     2,     3,     2,     1,     4,     4,     0,
    11,     3,     0,     1,     1,     0,     1,     1,     1,     1,
     1,     1,     1,     2,     2,     2,     1,    10,    10,     7,
     1,     0,     0,     5,     0,     9,     1,     3,     2,     1,
     3,     2,     0,     3,     4,     5,     1,     0,     6,     2,
     4,     0,     1,     1,     0,     1,     0,     5,     5,     3,
     4,     1,     0,     4,     4,     3,     1,     3,     2,     3,
     2,     3,     7,     5,     1,     0,     0,     2,     3,     1,
     3,     1,     1,     1,     4,     4,     1,     0,     0,     0,
     0,     6,     3,     1,     2,     1,     2,     2,     2,     2,
     1,     3,     1,     1,     1,     3,     5,     1,     1,     2,
     5,     1,     1,     1,     1,     0,     3,     1,     0,     1,
     0,     1,     1,     2,     1,     3,     1,     3,     1,     1,
     0,     2,     0,     0,     6,     0,     1,     0,     3,     0,
     2,     0,     1,     0,     1,     0,     1,     0,     4,     0,
     1,     1,     0,     2,     1,     1,     0,     1,     3,     3,
     3,     3,     2,     1,     3,     4,     1,     2,     2,     1,
     0,     1,     2,     1,     2,     1,     1,     1,     2,     4,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
     1,     3,     1,     1,     1,     1,     1,     6,     2,     1,
     0,     5,     3,     2,     3,     0,     3,     5,     4,     0,
     0,     5,     2,     2,     2,     3,     0,     2,     0,     7,
     7,     4,     1,     0,     2,     3,     6,     2,     1,     1,
     2,     0,     1,     0,     1,     0,     1,     0,     1,     0,
     1,     0,     1,     4
};

static const short yydefact[] = {     1,
     3,     0,    14,    45,     0,     2,    20,   304,     0,     0,
     7,   238,    70,    69,    67,   237,    68,     0,    15,   230,
   169,    19,     0,    66,    18,   237,   303,     0,   237,    57,
    87,     0,   237,   107,     0,   312,   237,   237,     0,   237,
   237,     0,     0,     0,     0,     0,     0,   310,     0,    23,
    24,    22,    25,    30,    29,    28,    31,    32,    33,    39,
    34,    27,    26,    35,    36,    37,    38,    40,    41,     0,
    42,    43,    13,     9,     0,    20,   238,     0,   236,     6,
   233,    17,   199,     0,    21,   160,   162,   163,   216,   199,
   164,     0,    51,    51,     0,    73,    75,    51,    58,    76,
    60,   305,     0,     0,    59,    62,    86,     0,   105,     0,
   106,     0,    44,   128,     0,   149,     0,     0,   151,   314,
    51,   157,   115,     0,   293,   294,   295,   311,    11,     0,
     8,    16,     0,   231,   232,     0,   198,   286,   201,   220,
   211,   205,   207,     0,   209,     0,     0,   277,   202,   203,
   168,   275,   276,   128,   222,   251,   192,   188,   189,   199,
   170,   174,   176,   181,   185,   184,   183,    65,     0,     0,
    48,    50,   317,    46,     0,     0,     0,     0,     0,    77,
    74,    49,   306,    63,    64,    61,    99,    98,    97,   100,
   101,   102,   103,    85,     0,   140,   323,     0,     0,   226,
   124,   127,   222,     0,   147,     0,     0,   146,   313,   150,
   152,     0,     0,   156,     0,   318,   291,     0,     0,    71,
   224,   290,   200,     0,   233,   283,   210,   204,   254,   274,
   256,     0,     0,     0,     0,   244,   247,   257,   252,     0,
     0,     0,   167,   222,   161,     0,     0,   168,   250,   194,
   195,   190,     0,   193,     0,     0,   199,   213,   175,   178,
   179,   180,     0,   177,    53,    52,   320,    83,    78,    84,
    79,    82,    80,    81,     0,   104,    88,    90,    89,   141,
     0,   222,   211,   225,   125,    51,   143,     0,     0,   144,
   145,   320,   158,   155,    55,    51,   117,   123,   120,     0,
   297,     0,   302,     0,   235,     0,   229,     0,   199,   197,
   224,     0,   243,     0,   255,   253,     0,   208,     0,     0,
   268,   269,   267,   266,   265,   264,     0,     0,     0,     0,
   206,   166,   221,   214,   165,   211,   248,   249,   182,   173,
     0,   171,     0,   319,     0,     0,     0,     0,     0,     0,
   112,   132,   126,   142,   138,   139,   148,     0,   159,     0,
   154,    54,     0,   114,   211,   119,   321,     0,   320,   299,
   292,     0,     0,    72,   234,     0,     0,   285,   219,   211,
   261,   262,   263,     0,   258,   273,     0,   271,   242,   239,
   240,   241,   211,   245,   281,     0,   218,     0,   212,   220,
   228,   186,    51,   307,     0,   324,     0,     0,   111,    51,
   315,   135,     0,    51,    56,   118,   122,   121,     0,     0,
     0,     0,   228,   287,     0,   259,     0,     0,   270,   246,
   280,     0,     0,   282,   217,   169,   191,   172,   227,     0,
    47,   233,   222,   222,   110,   133,   134,   137,   130,   153,
     0,   298,   296,   309,   301,   300,     0,   289,   211,   272,
   279,   278,   215,   187,   224,   112,   112,   136,   129,     0,
    51,   308,   288,   260,   223,     0,    51,    51,   131,   116,
    93,   108,   109,     0,    91,    96,    94,    95,    92,     0,
     0,     0
};

static const short yydefgoto[] = {   490,
     2,     6,     7,    75,     8,     9,    18,    19,    20,    21,
    49,    10,    50,    51,   171,   172,   361,   362,    52,   105,
   106,    22,    23,    24,   304,    53,    96,    54,    55,   180,
    56,   347,   485,   489,   194,    57,    58,    59,   410,    60,
   215,   216,   296,   297,   298,   366,    61,   201,   202,   412,
   448,   469,    62,   355,    63,   208,    64,    65,    66,    67,
   295,   214,    85,    86,    87,    88,   244,    89,    90,   258,
   400,   161,   162,   163,   164,   264,   165,   166,   253,   167,
   139,   224,   148,   149,   150,   228,   342,   155,   397,   436,
   226,   248,   306,   285,   440,    82,   136,   307,    78,    79,
   235,   236,   254,   255,   237,   386,   328,   238,   387,   388,
   239,   151,   152,   433,   153,    91,   140,   222,   309,    68,
   301,   371,   420,    69,    70,    71,   455,    72,   113,   210,
   413,   175,   345,   368,   299
};

static const short yypact[] = {    23,
-32768,   244,-32768,-32768,    60,-32768,   178,   329,    31,     7,
-32768,    28,-32768,-32768,-32768,   114,-32768,    16,-32768,   113,
    44,-32768,   114,-32768,-32768,   188,   150,   114,   114,    46,
   162,   168,   114,   114,   114,-32768,   114,   114,   177,   114,
   114,   134,   114,   207,   114,   220,    57,   233,   137,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   158,
-32768,-32768,-32768,-32768,   156,   188,-32768,   218,-32768,-32768,
   201,-32768,   153,    12,-32768,   221,-32768,-32768,-32768,    36,
-32768,   114,   -27,    39,   -29,   114,-32768,   -27,-32768,-32768,
-32768,   275,   279,   288,    63,-32768,   155,   285,-32768,   290,
-32768,   286,-32768,    15,   249,-32768,   270,   102,-32768,   293,
    39,   251,   302,   312,-32768,-32768,-32768,-32768,-32768,    35,
-32768,-32768,   305,-32768,-32768,   282,-32768,-32768,   317,   301,
   316,-32768,-32768,    10,-32768,   151,    10,-32768,-32768,-32768,
   223,-32768,-32768,   249,     9,    45,-32768,-32768,-32768,    36,
   225,    24,-32768,   175,-32768,-32768,-32768,-32768,   325,   336,
-32768,-32768,-32768,-32768,   332,   167,   215,   224,   340,-32768,
-32768,-32768,   235,-32768,-32768,-32768,-32768,-32768,   345,-32768,
-32768,-32768,-32768,-32768,    21,   339,   232,   351,   352,   344,
-32768,-32768,   322,    62,   276,   350,   356,-32768,-32768,-32768,
-32768,   353,   359,   315,   286,   281,-32768,   266,   375,-32768,
   369,    49,-32768,    18,   201,-32768,-32768,-32768,   273,-32768,
-32768,    10,    10,   252,   -14,-32768,   330,-32768,-32768,    12,
    12,    70,-32768,   322,-32768,   373,   384,   223,-32768,-32768,
-32768,-32768,   382,-32768,   186,   -36,    36,   318,-32768,-32768,
-32768,-32768,   376,-32768,-32768,-32768,   357,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   380,-32768,-32768,-32768,-32768,-32768,
   387,   164,   316,-32768,-32768,   -27,   294,   337,   392,-32768,
-32768,   357,   394,-32768,   304,    87,-32768,   409,     2,   400,
   306,   176,-32768,    29,   411,   412,-32768,    34,   153,-32768,
   369,     6,-32768,   -19,-32768,-32768,    10,-32768,    10,    10,
-32768,-32768,-32768,-32768,-32768,-32768,   410,     6,    12,    12,
-32768,-32768,-32768,-32768,-32768,   316,-32768,-32768,-32768,    24,
    10,-32768,    -9,-32768,   404,   308,    29,   307,   286,   286,
   397,    40,-32768,-32768,-32768,-32768,-32768,   413,-32768,   418,
-32768,-32768,   286,-32768,   316,-32768,-32768,   286,   357,-32768,
-32768,   314,   319,-32768,-32768,    94,   415,-32768,-32768,   316,
-32768,-32768,-32768,   419,-32768,-32768,   122,-32768,-32768,   138,
   328,-32768,   316,-32768,    59,   320,   331,   333,   125,   301,
   425,-32768,   -27,-32768,   393,-32768,   437,   438,-32768,   -27,
-32768,   228,   286,   -27,-32768,-32768,-32768,-32768,   429,     8,
   439,   439,   425,-32768,   334,-32768,   335,     6,-32768,-32768,
-32768,   430,   338,-32768,-32768,-32768,-32768,-32768,-32768,   341,
-32768,   201,   322,   322,-32768,-32768,-32768,   390,     2,-32768,
   286,-32768,-32768,-32768,   440,   440,   342,-32768,   316,-32768,
-32768,-32768,-32768,-32768,   434,   397,   397,-32768,-32768,   286,
    87,-32768,-32768,-32768,-32768,   447,   -27,   -27,-32768,-32768,
   358,-32768,-32768,   443,-32768,   200,-32768,-32768,-32768,   452,
   454,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   379,-32768,-32768,
-32768,-32768,-32768,-32768,   -94,-32768,-32768,-32768,-32768,-32768,
   354,   435,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -168,-32768,
-32768,-32768,    11,    97,-32768,-32768,-32768,   309,   349,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   217,    30,-32768,-32768,
-32768,   310,   210,  -155,-32768,-32768,-32768,-32768,-32768,   -80,
-32768,-32768,   245,  -258,-32768,  -275,-32768,-32768,-32768,-32768,
    68,  -201,    13,-32768,    48,-32768,  -220,   161,   303,   152,
  -141,-32768,   236,-32768,  -297,   146,-32768,-32768,-32768,    47,
   242,  -174,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    55,-32768,-32768,-32768,
-32768,   -84,  -266,    32,  -111
};


#define	YYLAST		481


static const short yytable[] = {   174,
   198,   286,   138,   182,   311,   242,   259,   352,   229,   230,
   452,   380,   229,   230,   385,   381,  -322,   141,   382,   383,
   231,   142,    -4,   141,   231,   358,   211,   142,  -199,  -199,
   385,   156,   157,  -199,   141,   277,   212,   218,   142,   278,
   158,   159,   332,   156,   157,   374,   376,   169,    99,   246,
  -196,  -318,   158,   159,  -316,   100,    73,   176,   177,   317,
   398,   431,   257,    83,   317,   329,   330,   125,   126,   199,
   318,   432,    11,  -284,   287,   178,   339,   179,   170,   319,
   351,   101,   320,   367,   319,   384,  -284,   320,   405,   417,
   313,   314,    84,   389,   143,   144,   411,   145,  -284,   401,
   143,   144,   419,   145,   426,   402,  -199,  -199,   200,  -199,
    74,   143,   232,   169,   205,   249,    77,   430,   279,    80,
   453,   233,   250,   146,   288,   234,     1,   247,   147,   234,
   385,   300,    76,   173,   147,   160,    77,    81,   102,   137,
  -199,   219,   377,   119,   170,   147,   103,   160,   317,   251,
   252,   137,  -284,   104,   395,   396,   127,   187,    25,    95,
   188,   169,   308,   103,   107,   206,   207,   189,   319,  -238,
   104,   320,   268,   109,    92,   390,   269,   391,   392,    97,
    12,   372,   108,   474,   259,   111,   112,   331,   373,   116,
    77,   353,   170,   120,   121,   363,   123,   240,   241,   399,
    13,   364,   423,   317,   246,    14,    15,    16,   424,   122,
    13,   190,   191,   192,   193,    14,    15,    16,   349,   350,
   270,   465,   124,   319,   271,    17,   320,    25,   378,   272,
   428,   134,   135,   273,   429,    17,   319,   407,   408,   320,
   129,   466,   467,   168,     3,   128,    -5,   181,    -5,    -5,
   130,    -5,    -5,    -5,   315,   230,   418,   337,   338,   131,
    -5,    -5,   133,    -5,   -10,   -10,    -5,   -10,   137,   -12,
   154,    -5,    -5,    -5,   260,   261,   -10,   183,   -10,   446,
   447,   184,   -10,   -10,   -10,   262,   -10,   -10,   263,   -10,
   185,    -5,    -5,   -10,   -10,   487,   488,   477,   478,   195,
   197,   449,   196,   199,   -10,   -10,   204,   209,   441,   -10,
   -10,   -10,   -10,   -10,   213,   445,  -113,   217,   221,   450,
   220,   223,   227,   257,     4,   243,    -5,    -5,    94,    -5,
   265,    98,     5,   -10,   -10,   110,   -10,   -10,   225,   114,
   115,   266,   117,   118,   267,   274,   275,   276,   281,    26,
    27,   280,    28,   282,   283,    -5,   284,   289,   479,    -5,
    -5,    29,   246,    30,   290,   292,   294,    31,    32,    33,
   291,    34,    35,   293,    36,   173,   480,   302,    37,    38,
   303,   305,   482,   483,   312,   333,   334,   336,   343,    39,
    40,   341,   346,   344,    41,    42,    43,    44,    45,   348,
   249,  -251,  -251,   354,   357,   321,   322,   323,   359,   356,
   360,   365,   369,  -223,   375,   393,   403,   370,    46,    47,
   404,   409,    48,   415,   406,   414,   421,   425,   427,   320,
   442,   422,   434,   435,   324,   325,   326,   439,   437,   443,
   444,   451,   461,   468,   454,   472,   475,   459,   458,   481,
   462,   491,   484,   492,   132,   464,   473,   486,   186,   416,
    93,   471,   245,   203,   335,   463,   340,   438,   310,   256,
   457,   379,   327,   394,   460,   316,   456,   476,     0,     0,
   470
};

static const short yycheck[] = {    94,
   112,   203,    83,    98,   225,   147,   162,   283,     3,     4,
     3,     6,     3,     4,   312,    10,    15,     6,    13,    14,
    15,    10,     0,     6,    15,   292,   121,    10,     5,     6,
   328,     8,     9,    10,     6,    15,   121,     3,    10,    19,
    17,    18,   244,     8,     9,   304,    13,    75,     3,    41,
     6,    13,    17,    18,    15,    10,    26,    87,    88,    79,
   336,     3,    99,    20,    79,   240,   241,    11,    12,    55,
    85,    13,    13,    25,    13,   105,   113,   107,   106,    99,
   282,    36,   102,    82,    99,    80,    38,   102,   347,   365,
   232,   233,    49,   113,    83,    84,    57,    86,    50,   109,
    83,    84,   369,    86,   380,   115,    83,    84,    94,    86,
   104,    83,   103,    75,    13,    71,     3,   393,    98,   104,
   113,   112,    78,   112,    63,   120,   104,   119,   117,   120,
   428,   216,   105,    95,   117,   112,     3,    25,    93,   116,
   117,   107,   109,    10,   106,   117,   101,   112,    79,   105,
   106,   116,   104,   108,   329,   330,   100,     3,     7,    10,
     6,    75,   114,   101,     3,    64,    65,    13,    99,    15,
   108,   102,     6,     6,    23,   317,    10,   319,   320,    28,
     3,     6,    31,   459,   340,    34,    35,   118,    13,    13,
     3,   286,   106,    42,    43,   109,    45,    47,    48,   341,
    23,   296,   109,    79,    41,    28,    29,    30,   115,     3,
    23,    57,    58,    59,    60,    28,    29,    30,    55,    56,
     6,   442,     3,    99,    10,    48,   102,    76,   309,     6,
   109,    31,    32,    10,   113,    48,    99,   349,   350,   102,
   104,   443,   444,    92,     1,    13,     3,    96,     5,     6,
    93,     8,     9,    10,     3,     4,   368,    72,    73,   104,
    17,    18,    45,    20,    21,    22,    23,    24,   116,    26,
    50,    28,    29,    30,   100,   101,    33,     3,    35,    52,
    53,     3,    39,    40,    41,   111,    43,    44,   114,    46,
     3,    48,    49,    50,    51,    96,    97,   466,   467,    15,
    15,   413,    13,    55,    61,    62,    37,    15,   403,    66,
    67,    68,    69,    70,    64,   410,    15,     6,    37,   414,
    16,     5,     7,    99,    81,   103,    83,    84,    26,    86,
     6,    29,    89,    90,    91,    33,    93,    94,    38,    37,
    38,     6,    40,    41,    13,     6,   112,     3,   117,    21,
    22,    13,    24,     3,     3,   112,    13,    82,   470,   116,
   117,    33,    41,    35,    15,    13,    52,    39,    40,    41,
    15,    43,    44,    15,    46,    95,   471,   112,    50,    51,
     6,    13,   477,   478,   112,    13,     3,     6,    13,    61,
    62,    74,    13,    37,    66,    67,    68,    69,    70,    13,
    71,    72,    73,   110,    13,    76,    77,    78,    15,    73,
   107,     3,    13,     3,     3,     6,    13,   112,    90,    91,
   113,    25,    94,     6,   118,    13,   113,    13,    10,   102,
    38,   113,   113,   103,   105,   106,   107,    13,   106,     3,
     3,    13,    13,    54,     6,     6,    13,   113,   115,     3,
   113,     0,    95,     0,    76,   115,   115,    15,   105,   363,
    26,   451,   154,   115,   248,   436,   257,   400,   224,   160,
   423,   311,   237,   328,   428,   234,   422,   465,    -1,    -1,
   449
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 352 "parser.y"
{ prepare_parse(); ;
    break;}
case 2:
#line 353 "parser.y"
{ if (generate_code)
		                           addHistoryLine();
		                         resetQueryBuffer();
					 YYACCEPT; ;
    break;}
case 3:
#line 357 "parser.y"
{ YYACCEPT; ;
    break;}
case 4:
#line 358 "parser.y"
{ YYACCEPT; ;
    break;}
case 5:
#line 361 "parser.y"
{ prepare_input(); ;
    break;}
case 6:
#line 362 "parser.y"
{ after_CorpusCommand(yyvsp[-1].cl); ;
    break;}
case 7:
#line 364 "parser.y"
{ 
		      if (yyvsp[0].ival == query_lock) {
			query_lock = 0;
		      }
		      else {
			fprintf(stderr, "ALERT! Query lock violation.\n");
			printf("\n"); /* so CQP.pm won't block -- should no longer be needed after switching to .EOL. mechanism */
			exit(1);
		      }
		    ;
    break;}
case 10:
#line 375 "parser.y"
{if (query_lock) {warn_query_lock_violation(); YYABORT;} ;
    break;}
case 11:
#line 376 "parser.y"
{ ;
    break;}
case 12:
#line 377 "parser.y"
{if (query_lock) {warn_query_lock_violation(); YYABORT;} ;
    break;}
case 13:
#line 378 "parser.y"
{ exit_cqp++; ;
    break;}
case 14:
#line 379 "parser.y"
{ /* in case of syntax errors, don't save 
					      history file */
		                           synchronize();
		                           resetQueryBuffer();
					   YYABORT; /* Oli did this:   yyerrok; */
					   /* but we don't want to continue processing a line, when part of it failed */
		                         ;
    break;}
case 15:
#line 388 "parser.y"
{ yyval.cl = yyvsp[0].cl; ;
    break;}
case 16:
#line 390 "parser.y"
{ yyval.cl = in_CorpusCommand(yyvsp[-2].strval, yyvsp[0].cl); ;
    break;}
case 17:
#line 394 "parser.y"
{ yyval.cl = in_UnnamedCorpusCommand(yyvsp[-1].cl); ;
    break;}
case 18:
#line 397 "parser.y"
{ if (query_lock) {warn_query_lock_violation(); YYABORT;} yyval.cl = ActivateCorpus(yyvsp[0].cl); ;
    break;}
case 19:
#line 398 "parser.y"
{ yyval.cl = after_CorpusSetExpr(yyvsp[0].cl); ;
    break;}
case 20:
#line 399 "parser.y"
{ prepare_Query(); ;
    break;}
case 21:
#line 400 "parser.y"
{ yyval.cl = after_Query(yyvsp[0].cl); ;
    break;}
case 45:
#line 430 "parser.y"
{ printf("-::-EOL-::-\n"); fflush(stdout); ;
    break;}
case 46:
#line 434 "parser.y"
{ do_cat(yyvsp[-1].cl, &(yyvsp[0].redir), 0, -1); ;
    break;}
case 47:
#line 437 "parser.y"
{ do_cat(yyvsp[-5].cl, &(yyvsp[0].redir), yyvsp[-3].ival, yyvsp[-1].ival); ;
    break;}
case 48:
#line 440 "parser.y"
{ if (generate_code) 
			      do_cat(yyvsp[-1].cl, &(yyvsp[0].redir), 0, -1);
			    drop_temp_corpora();
			  ;
    break;}
case 49:
#line 447 "parser.y"
{ do_save(yyvsp[-1].cl, &(yyvsp[0].redir)); cl_free(yyvsp[0].redir.name); ;
    break;}
case 51:
#line 451 "parser.y"
{ yyval.redir.name = (char *)NULL;
					  yyval.redir.mode = (char *)NULL;
                                          yyval.redir.stream = stdout;
                                          yyval.redir.is_pipe = 0;
                                        ;
    break;}
case 52:
#line 458 "parser.y"
{ yyval.redir.name = yyvsp[0].strval;
					  yyval.redir.mode = "w";
                                          yyval.redir.stream = NULL;
                                          yyval.redir.is_pipe = 0;
					;
    break;}
case 53:
#line 463 "parser.y"
{ yyval.redir.name = yyvsp[0].strval;
					  yyval.redir.mode = "a";
                                          yyval.redir.stream = NULL;
                                          yyval.redir.is_pipe = 0;
					;
    break;}
case 55:
#line 472 "parser.y"
{ yyval.in_redir.name = (char *)NULL;
                                          yyval.in_redir.stream = stdin;
                                          yyval.in_redir.is_pipe = 0;
                                        ;
    break;}
case 56:
#line 478 "parser.y"
{ yyval.in_redir.name = yyvsp[0].strval;
                                          yyval.in_redir.stream = NULL;
                                          yyval.in_redir.is_pipe = 0;
					;
    break;}
case 57:
#line 484 "parser.y"
{ 
					  show_corpora_files(UNDEF);
					;
    break;}
case 58:
#line 487 "parser.y"
{ 
                                          if (strncasecmp(yyvsp[0].strval, "var", 3) == 0) {
					    do_PrintAllVariables();
					  }
					  else if ((strncasecmp(yyvsp[0].strval, "sys", 3) == 0) || (strncasecmp(yyvsp[0].strval, "corp", 4) == 0)) {
					    show_corpora_files(SYSTEM);
					  }
					  else if ((strncasecmp(yyvsp[0].strval, "sub", 3) == 0) || (strcasecmp(yyvsp[0].strval, "named") == 0) || (strcasecmp(yyvsp[0].strval, "queries") == 0)) {
					    show_corpora_files(SUB);	
					  }
					  else {
					    cqpmessage(Error, "show what?");
					  }
		                        ;
    break;}
case 60:
#line 504 "parser.y"
{ PrintContextDescriptor(&CD); ;
    break;}
case 63:
#line 514 "parser.y"
{ do_attribute_show(yyvsp[0].strval, 1); ;
    break;}
case 64:
#line 515 "parser.y"
{ do_attribute_show(yyvsp[0].strval, 0); ;
    break;}
case 65:
#line 518 "parser.y"
{ if (query_lock) {warn_query_lock_violation(); YYABORT;} yyval.cl = do_setop(yyvsp[-2].rngsetop, yyvsp[-1].cl, yyvsp[0].cl); ;
    break;}
case 67:
#line 522 "parser.y"
{ yyval.rngsetop = RUnion; ;
    break;}
case 68:
#line 523 "parser.y"
{ yyval.rngsetop = RUnion; ;
    break;}
case 69:
#line 524 "parser.y"
{ yyval.rngsetop = RIntersection; ;
    break;}
case 70:
#line 525 "parser.y"
{ yyval.rngsetop = RDiff; ;
    break;}
case 71:
#line 531 "parser.y"
{ 
  					  do_start_timer();
   					  prepare_do_subset(yyvsp[-2].cl, yyvsp[0].field);  
					  next_environment();	/* create environment for pattern compilation (will be freed in prepare_input() before next command) */
					;
    break;}
case 72:
#line 536 "parser.y"
{ 
		                          if (generate_code) {
					    yyval.cl = do_subset(yyvsp[-2].field, yyvsp[0].boolt);
					    do_timing("Subset computed");
					  }
					  else 
					    yyval.cl = NULL;
		                        ;
    break;}
case 73:
#line 547 "parser.y"
{  ;
    break;}
case 74:
#line 550 "parser.y"
{ if (yyvsp[0].cl)
					    dropcorpus(yyvsp[0].cl);
					;
    break;}
case 75:
#line 553 "parser.y"
{ if (yyvsp[0].cl)
					    dropcorpus(yyvsp[0].cl);
					;
    break;}
case 76:
#line 558 "parser.y"
{ do_PrintVariableValue(yyvsp[0].strval); 
                                    free(yyvsp[0].strval);
                                  ;
    break;}
case 77:
#line 565 "parser.y"
{ do_SetVariableValue(yyvsp[-1].strval, 
							yyvsp[0].varsetting.operator, 
							yyvsp[0].varsetting.variableValue); 
		                    free(yyvsp[-1].strval);
				    free(yyvsp[0].varsetting.variableValue);
                                  ;
    break;}
case 78:
#line 572 "parser.y"
{
				    do_AddSubVariables(yyvsp[-2].strval, /*add*/1, yyvsp[0].strval);
				    free(yyvsp[-2].strval);
				    free(yyvsp[0].strval);
				  ;
    break;}
case 79:
#line 578 "parser.y"
{
				    do_AddSubVariables(yyvsp[-2].strval, /*sub*/0, yyvsp[0].strval);
				    free(yyvsp[-2].strval);
				    free(yyvsp[0].strval);
				  ;
    break;}
case 80:
#line 584 "parser.y"
{
				    char *temp = cl_strdup("");
				    do_SetVariableValue(yyvsp[-2].strval, '=', temp);		/* cheap trick, this is :o) */
				    free(temp);
				    do_AddSubVariables(yyvsp[-2].strval, /*add*/1, yyvsp[0].strval);
				    free(yyvsp[-2].strval);
				    free(yyvsp[0].strval);
				  ;
    break;}
case 81:
#line 595 "parser.y"
{ yyval.varsetting.variableValue = yyvsp[0].strval; yyval.varsetting.operator = '<'; ;
    break;}
case 82:
#line 596 "parser.y"
{ yyval.varsetting.variableValue = yyvsp[0].strval; yyval.varsetting.operator = '='; ;
    break;}
case 83:
#line 597 "parser.y"
{ yyval.varsetting.variableValue = yyvsp[0].strval; yyval.varsetting.operator = '+'; ;
    break;}
case 84:
#line 598 "parser.y"
{ yyval.varsetting.variableValue = yyvsp[0].strval; yyval.varsetting.operator = '-'; ;
    break;}
case 85:
#line 601 "parser.y"
{ char *msg;

                                          if (yyvsp[0].varval.cval != NULL && yyvsp[0].varval.ival >= 0) {
					    msg = set_context_option_value(yyvsp[-1].strval, yyvsp[0].varval.cval, yyvsp[0].varval.ival);
					  }
					  else if (yyvsp[0].varval.cval != NULL) {
					    if ((yyvsp[0].varval.cval[0] == '"') &&
						(yyvsp[0].varval.cval[strlen(yyvsp[0].varval.cval)-1] == '"')) {
					      
				            /* get rid of quotes at beg and end of value */

					      yyvsp[0].varval.cval[strlen(yyvsp[0].varval.cval)-1] = '\0';
					      yyvsp[0].varval.cval = yyvsp[0].varval.cval + 1;
					    }
					    msg = set_string_option_value(yyvsp[-1].strval, yyvsp[0].varval.cval);
					  }
					  else
					    msg = set_integer_option_value(yyvsp[-1].strval, yyvsp[0].varval.ival);

                                          if (msg != NULL)
					    cqpmessage(Warning,
						       "Option set error:\n%s", msg);
                                        ;
    break;}
case 86:
#line 624 "parser.y"
{ int opt;

					  if ((opt = find_option(yyvsp[0].strval)) >= 0)
					    print_option_value(opt);
					  else
					    cqpmessage(Warning,
						     "Unknown option: ``%s''\n", yyvsp[0].strval);
                                        ;
    break;}
case 87:
#line 632 "parser.y"
{
					  print_option_values();
                                        ;
    break;}
case 88:
#line 635 "parser.y"
{ do_set_target(yyvsp[-2].cl, yyvsp[-1].field, yyvsp[0].field); ;
    break;}
case 89:
#line 636 "parser.y"
{ do_set_target(yyvsp[-2].cl, yyvsp[-1].field, NoField); ;
    break;}
case 90:
#line 637 "parser.y"
{
					  if (generate_code) {
					    old_query_corpus = query_corpus;
					    query_corpus = yyvsp[-2].cl;  /* set query_corpus for compiling the ExtConstraint pattern */
					    next_environment();	/* create environment for pattern compilation (will be freed in prepare_input() before next command) */
					    do_start_timer();
					  }
					;
    break;}
case 91:
#line 647 "parser.y"
{
					  do_set_complex_target(yyvsp[-9].cl, yyvsp[-8].field, yyvsp[-7].search_strategy, yyvsp[-5].boolt, yyvsp[-3].direction, yyvsp[-2].ival, yyvsp[-1].strval, yyvsp[0].base.field, yyvsp[0].base.inclusive);
					  if (generate_code) 
					    do_timing("``set target ...'' completed");
                                        ;
    break;}
case 92:
#line 654 "parser.y"
{
                                          /* from (match|keyword|target) [inclusive|exclusive] */
					  yyval.base.field = yyvsp[-1].field;
					  yyval.base.inclusive = yyvsp[0].ival;
                                        ;
    break;}
case 93:
#line 659 "parser.y"
{ 
                                          yyval.base.field = MatchField;
					  yyval.base.inclusive = 0;
                                        ;
    break;}
case 94:
#line 665 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 95:
#line 666 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 96:
#line 667 "parser.y"
{ yyval.ival = 0; /* default is exclusive */ ;
    break;}
case 97:
#line 670 "parser.y"
{ yyval.varval.ival = yyvsp[0].ival;
					  yyval.varval.cval = NULL;
					  yyval.varval.ok = 1;
                                        ;
    break;}
case 98:
#line 674 "parser.y"
{ yyval.varval.ival = -1;
					  yyval.varval.cval = yyvsp[0].strval;
					  yyval.varval.ok = 1;
	                                ;
    break;}
case 99:
#line 678 "parser.y"
{
					  yyval.varval.ival = -1;
					  yyval.varval.cval = yyvsp[0].strval;
					  yyval.varval.ok = 1;
	                                ;
    break;}
case 100:
#line 683 "parser.y"
{ yyval.varval.ival = 1; yyval.varval.cval = NULL; yyval.varval.ok = 1; ;
    break;}
case 101:
#line 684 "parser.y"
{ yyval.varval.ival = 1; yyval.varval.cval = NULL; yyval.varval.ok = 1; ;
    break;}
case 102:
#line 685 "parser.y"
{ yyval.varval.ival = 0; yyval.varval.cval = NULL; yyval.varval.ok = 1; ;
    break;}
case 103:
#line 686 "parser.y"
{ yyval.varval.ival = 0; yyval.varval.cval = NULL; yyval.varval.ok = 1; ;
    break;}
case 104:
#line 687 "parser.y"
{
					  yyval.varval.ival = yyvsp[-1].ival;
					  yyval.varval.cval = yyvsp[0].strval;
					  yyval.varval.ok = 1;
                                        ;
    break;}
case 105:
#line 694 "parser.y"
{ do_exec(yyvsp[0].strval); ;
    break;}
case 106:
#line 697 "parser.y"
{ do_info(yyvsp[0].cl); ;
    break;}
case 107:
#line 698 "parser.y"
{ do_info(current_corpus); ;
    break;}
case 108:
#line 703 "parser.y"
{ 
				  do_group(yyvsp[-8].cl, yyvsp[-7].Anchor.anchor, yyvsp[-7].Anchor.offset, yyvsp[-6].strval, yyvsp[-4].Anchor.anchor, yyvsp[-4].Anchor.offset, yyvsp[-3].strval, yyvsp[-2].ival, yyvsp[-1].ival, &(yyvsp[0].redir)); 
				  cl_free(yyvsp[0].redir.name);
				;
    break;}
case 109:
#line 709 "parser.y"
{ 
                                  do_group(yyvsp[-8].cl, yyvsp[-7].Anchor.anchor, yyvsp[-7].Anchor.offset, yyvsp[-6].strval, yyvsp[-4].Anchor.anchor, yyvsp[-4].Anchor.offset, yyvsp[-3].strval, yyvsp[-2].ival, yyvsp[-1].ival, &(yyvsp[0].redir));
				  cl_free(yyvsp[0].redir.name);
				;
    break;}
case 110:
#line 715 "parser.y"
{ 
                                  do_group2(yyvsp[-5].cl, yyvsp[-4].Anchor.anchor, yyvsp[-4].Anchor.offset, yyvsp[-3].strval, yyvsp[-2].ival, yyvsp[-1].ival, &(yyvsp[0].redir));
				  cl_free(yyvsp[0].redir.name);
				;
    break;}
case 111:
#line 722 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 112:
#line 723 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 113:
#line 729 "parser.y"
{ free_tabulation_list(); ;
    break;}
case 114:
#line 731 "parser.y"
{ print_tabulation(yyvsp[-3].cl, 0, INT_MAX, &(yyvsp[0].redir)); cl_free(yyvsp[0].redir.name); ;
    break;}
case 115:
#line 733 "parser.y"
{ free_tabulation_list(); ;
    break;}
case 116:
#line 735 "parser.y"
{ print_tabulation(yyvsp[-7].cl, yyvsp[-4].ival, yyvsp[-2].ival, &(yyvsp[0].redir)); cl_free(yyvsp[0].redir.name); ;
    break;}
case 117:
#line 739 "parser.y"
{ append_tabulation_item(yyvsp[0].tabulation_item); ;
    break;}
case 118:
#line 741 "parser.y"
{ append_tabulation_item(yyvsp[0].tabulation_item); ;
    break;}
case 119:
#line 745 "parser.y"
{
		     yyval.tabulation_item = new_tabulation_item();
		     yyval.tabulation_item->attribute_name = yyvsp[0].AttributeSpecification.name;
		     yyval.tabulation_item->flags   = yyvsp[0].AttributeSpecification.flags;
		     yyval.tabulation_item->anchor1 = yyvsp[-1].AnchorPair.anchor1;
		     yyval.tabulation_item->offset1 = yyvsp[-1].AnchorPair.offset1;
		     yyval.tabulation_item->anchor2 = yyvsp[-1].AnchorPair.anchor2;
		     yyval.tabulation_item->offset2 = yyvsp[-1].AnchorPair.offset2;
		   ;
    break;}
case 120:
#line 757 "parser.y"
{ yyval.AnchorPair.anchor1 = yyval.AnchorPair.anchor2 = yyvsp[0].Anchor.anchor; yyval.AnchorPair.offset1 = yyval.AnchorPair.offset2 = yyvsp[0].Anchor.offset; ;
    break;}
case 121:
#line 759 "parser.y"
{ yyval.AnchorPair.anchor1 = yyvsp[-2].Anchor.anchor; yyval.AnchorPair.offset1 = yyvsp[-2].Anchor.offset;
	               yyval.AnchorPair.anchor2 = yyvsp[0].Anchor.anchor; yyval.AnchorPair.offset2 = yyvsp[0].Anchor.offset; ;
    break;}
case 122:
#line 764 "parser.y"
{ yyval.AttributeSpecification.name = yyvsp[-1].strval; yyval.AttributeSpecification.flags = yyvsp[0].ival; ;
    break;}
case 123:
#line 766 "parser.y"
{ yyval.AttributeSpecification.name = NULL; yyval.AttributeSpecification.flags = 0; ;
    break;}
case 124:
#line 776 "parser.y"
{ 
		  int ok;
		  if (yyvsp[-1].cl && generate_code) {
		    do_start_timer();
		    ok = SortSubcorpus(yyvsp[-1].cl, yyvsp[0].sortclause, 0, NULL);
		    FreeSortClause(yyvsp[0].sortclause);
		    do_timing("Query result sorted");
		    if (autoshow && ok && (yyvsp[-1].cl->size > 0))
		      catalog_corpus(yyvsp[-1].cl, NULL, 0, -1, GlobalPrintMode);
		  }
                ;
    break;}
case 125:
#line 788 "parser.y"
{
		  int ok;
		  if (yyvsp[-2].cl && generate_code) {
		    do_start_timer();
		    ok = SortSubcorpusRandomize(yyvsp[-2].cl, yyvsp[0].ival);
		    do_timing("Query result randomized");
		    if (autoshow && ok && (yyvsp[-2].cl->size > 0))
		      catalog_corpus(yyvsp[-2].cl, NULL, 0, -1, GlobalPrintMode);
		  }
                ;
    break;}
case 126:
#line 799 "parser.y"
{ 
                  int ok;
		  if (yyvsp[-3].cl && generate_code) {
		    ok = SortSubcorpus(yyvsp[-3].cl, yyvsp[-2].sortclause, (yyvsp[-1].ival >= 1) ? yyvsp[-1].ival : 1, &(yyvsp[0].redir));
		    FreeSortClause(yyvsp[-2].sortclause);
		    cl_free(yyvsp[0].redir.name);
		  }
                ;
    break;}
case 127:
#line 810 "parser.y"
{ yyval.sortclause = yyvsp[0].sortclause; ;
    break;}
case 128:
#line 811 "parser.y"
{ yyval.sortclause = NULL; ;
    break;}
case 129:
#line 815 "parser.y"
{
		  if (generate_code) {
		    yyval.sortclause = cl_malloc(sizeof(SortClauseBuffer));
		    yyval.sortclause->attribute_name 	= yyvsp[-4].strval;
		    yyval.sortclause->flags   	= yyvsp[-3].ival;
		    yyval.sortclause->anchor1 	= yyvsp[-2].AnchorPair.anchor1;
	 	    yyval.sortclause->offset1 	= yyvsp[-2].AnchorPair.offset1;
		    yyval.sortclause->anchor2 	= yyvsp[-2].AnchorPair.anchor2;
	 	    yyval.sortclause->offset2 	= yyvsp[-2].AnchorPair.offset2;
		    yyval.sortclause->sort_ascending 	= yyvsp[-1].ival;
		    yyval.sortclause->sort_reverse 	= yyvsp[0].ival;
		  }
		  else
		    yyval.sortclause = NULL;
		;
    break;}
case 130:
#line 832 "parser.y"
{ yyval.AnchorPair.anchor1 = yyval.AnchorPair.anchor2 = yyvsp[0].Anchor.anchor; yyval.AnchorPair.offset1 = yyval.AnchorPair.offset2 = yyvsp[0].Anchor.offset; ;
    break;}
case 131:
#line 834 "parser.y"
{ yyval.AnchorPair.anchor1 = yyvsp[-2].Anchor.anchor; yyval.AnchorPair.offset1 = yyvsp[-2].Anchor.offset;
			      yyval.AnchorPair.anchor2 = yyvsp[0].Anchor.anchor; yyval.AnchorPair.offset2 = yyvsp[0].Anchor.offset; ;
    break;}
case 132:
#line 837 "parser.y"
{ yyval.AnchorPair.anchor1 = MatchField;	  yyval.AnchorPair.offset1 = 0;
			      yyval.AnchorPair.anchor2 = MatchEndField; yyval.AnchorPair.offset2 = 0; ;
    break;}
case 133:
#line 841 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 134:
#line 842 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 135:
#line 843 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 136:
#line 846 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 137:
#line 847 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 138:
#line 853 "parser.y"
{
					  do_reduce(yyvsp[-3].cl, yyvsp[-1].ival, yyvsp[0].ival);
					;
    break;}
case 139:
#line 857 "parser.y"
{
					  RangeSetop(yyvsp[-3].cl, RMaximalMatches, NULL, NULL);
					;
    break;}
case 140:
#line 861 "parser.y"
{
					  do_cut(yyvsp[-1].cl, 0, yyvsp[0].ival-1);
					;
    break;}
case 141:
#line 865 "parser.y"
{
					  do_cut(yyvsp[-2].cl, yyvsp[-1].ival, yyvsp[0].ival);
					;
    break;}
case 142:
#line 870 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 143:
#line 871 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 144:
#line 875 "parser.y"
{
					  if (yyvsp[-2].cl && generate_code) {
					    do_delete_lines(yyvsp[-2].cl, yyvsp[0].field, SELECTED_LINES); 
					  }
					;
    break;}
case 145:
#line 881 "parser.y"
{ 
					  if (yyvsp[-2].cl && generate_code) {
					    do_delete_lines(yyvsp[-2].cl, yyvsp[0].field, UNSELECTED_LINES); 
					  }
					;
    break;}
case 146:
#line 887 "parser.y"
{ 
					  if (yyvsp[-1].cl && generate_code) {
					     do_delete_lines_num(yyvsp[-1].cl, yyvsp[0].Distance.mindist, yyvsp[0].Distance.maxdist);
				 	   }
					 ;
    break;}
case 147:
#line 894 "parser.y"
{ yyval.Distance.mindist = yyvsp[0].ival; yyval.Distance.maxdist = yyvsp[0].ival; ;
    break;}
case 148:
#line 895 "parser.y"
{ yyval.Distance.mindist = yyvsp[-2].ival; yyval.Distance.maxdist = yyvsp[0].ival; ;
    break;}
case 149:
#line 900 "parser.y"
{ do_sleep(yyvsp[0].ival); ;
    break;}
case 150:
#line 904 "parser.y"
{ do_size(yyvsp[-1].cl, yyvsp[0].field); ;
    break;}
case 151:
#line 905 "parser.y"
{ do_printVariableSize(yyvsp[0].strval); free(yyvsp[0].strval); ;
    break;}
case 152:
#line 910 "parser.y"
{ do_dump(yyvsp[-1].cl, 0, INT_MAX, &(yyvsp[0].redir)); cl_free(yyvsp[0].redir.name); ;
    break;}
case 153:
#line 912 "parser.y"
{ do_dump(yyvsp[-5].cl, yyvsp[-3].ival, yyvsp[-1].ival, &(yyvsp[0].redir)); cl_free(yyvsp[0].redir.name); ;
    break;}
case 154:
#line 916 "parser.y"
{ do_undump(yyvsp[-3].strval, yyvsp[-2].ival, !yyvsp[-1].ival, &(yyvsp[0].in_redir)); cl_free(yyvsp[0].in_redir.name); ;
    break;}
case 155:
#line 919 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 156:
#line 920 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 157:
#line 924 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 158:
#line 926 "parser.y"
{ 
	    if (yyvsp[0].field == TargetField) { yyval.ival = 1; }
	    else { yyerror("Invalid extension anchor in undump command"); YYABORT; } 
	  ;
    break;}
case 159:
#line 931 "parser.y"
{ 
	    if ( ((yyvsp[-1].field == TargetField) && (yyvsp[0].field == KeywordField))
		 || ((yyvsp[0].field == TargetField) && (yyvsp[-1].field == KeywordField))
	       ) { yyval.ival = 2; }
	    else { yyerror("Invalid extension anchor in undump command"); YYABORT; } 
	  ;
    break;}
case 161:
#line 943 "parser.y"
{
		  if (yyvsp[-2].cl && yyvsp[0].sortclause && yyvsp[-2].cl->size > 0) {
		    SortSubcorpus(yyvsp[-2].cl, yyvsp[0].sortclause, 0, NULL);
		    FreeSortClause(yyvsp[0].sortclause);
		  }
		  yyval.cl = yyvsp[-2].cl;
		;
    break;}
case 165:
#line 959 "parser.y"
{ yyval.cl = do_StandardQuery(yyvsp[-1].ival, yyvsp[0].ival); ;
    break;}
case 166:
#line 963 "parser.y"
{ yyval.cl = do_MUQuery(yyvsp[-2].evalt, yyvsp[-1].ival, yyvsp[0].ival); ;
    break;}
case 167:
#line 966 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 168:
#line 967 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 169:
#line 970 "parser.y"
{ if (generate_code) { CurEnv->match_label = labellookup(CurEnv->labels, "match", LAB_DEFINED, 1); } ;
    break;}
case 170:
#line 971 "parser.y"
{ within_gc = 1; 
		                          if (generate_code) { CurEnv->matchend_label = labellookup(CurEnv->labels, "matchend", LAB_DEFINED, 1); } ;
    break;}
case 171:
#line 973 "parser.y"
{ within_gc = 0; ;
    break;}
case 172:
#line 974 "parser.y"
{ do_SearchPattern(yyvsp[-4].evalt, yyvsp[-2].boolt); ;
    break;}
case 173:
#line 978 "parser.y"
{ yyval.evalt = reg_disj(yyvsp[-2].evalt, yyvsp[0].evalt); ;
    break;}
case 174:
#line 979 "parser.y"
{ yyval.evalt = yyvsp[0].evalt; ;
    break;}
case 175:
#line 983 "parser.y"
{ yyval.evalt = reg_seq(yyvsp[-1].evalt, yyvsp[0].evalt); ;
    break;}
case 176:
#line 984 "parser.y"
{ yyval.evalt = yyvsp[0].evalt; ;
    break;}
case 177:
#line 987 "parser.y"
{ if (generate_code) {
					   yyval.evalt = yyvsp[0].evalt;
					   yyval.evalt->node.left = yyvsp[-1].evalt;
					   yyval.evalt->node.right = NULL;
					 }
					 else
					   yyval.evalt = NULL;
				       ;
    break;}
case 178:
#line 995 "parser.y"
{ if (generate_code)
					   NEW_EVALNODE(yyval.evalt, re_repeat, yyvsp[-1].evalt, NULL, 0, repeat_inf);
					 else
					   yyval.evalt = NULL;
				       ;
    break;}
case 179:
#line 1000 "parser.y"
{ if (generate_code)
					   NEW_EVALNODE(yyval.evalt, re_repeat, yyvsp[-1].evalt, NULL, 1, repeat_inf);
					 else
					   yyval.evalt = NULL;
				       ;
    break;}
case 180:
#line 1005 "parser.y"
{ if (generate_code)
					   NEW_EVALNODE(yyval.evalt, re_repeat, yyvsp[-1].evalt, NULL, 0, 1);
					 else
					   yyval.evalt = NULL;
				       ;
    break;}
case 181:
#line 1010 "parser.y"
{ yyval.evalt = yyvsp[0].evalt; ;
    break;}
case 182:
#line 1013 "parser.y"
{ yyval.evalt = yyvsp[-1].evalt; ;
    break;}
case 183:
#line 1014 "parser.y"
{ if (generate_code)
					    NEW_EVALLEAF(yyval.evalt, yyvsp[0].index);
					  else
					    yyval.evalt = NULL;
					;
    break;}
case 184:
#line 1019 "parser.y"
{ if (generate_code)
					    NEW_EVALLEAF(yyval.evalt, yyvsp[0].index);
					  else
					    yyval.evalt = NULL;
					;
    break;}
case 185:
#line 1024 "parser.y"
{ if (generate_code)
					    NEW_EVALLEAF(yyval.evalt, yyvsp[0].index);
					  else
					    yyval.evalt = NULL;
					;
    break;}
case 186:
#line 1031 "parser.y"
{ if (generate_code)
					    NEW_EVALNODE(yyval.evalt, re_repeat, NULL, NULL, yyvsp[-1].ival, yyvsp[-1].ival);
					  else
					    yyval.evalt = NULL;
					;
    break;}
case 187:
#line 1037 "parser.y"
{ if (generate_code)
					    NEW_EVALNODE(yyval.evalt, re_repeat, NULL, NULL, yyvsp[-3].ival, yyvsp[-1].ival);
					  else
					    yyval.evalt = NULL;
					;
    break;}
case 188:
#line 1045 "parser.y"
{ yyval.index = do_AnchorPoint(yyvsp[0].field, 0); ;
    break;}
case 189:
#line 1046 "parser.y"
{ yyval.index = do_AnchorPoint(yyvsp[0].field, 1); ;
    break;}
case 190:
#line 1049 "parser.y"
{ yyval.index = do_XMLTag(yyvsp[-1].strval, 0, 0, NULL, 0); ;
    break;}
case 191:
#line 1051 "parser.y"
{ yyval.index = do_XMLTag(yyvsp[-4].strval, 0, yyvsp[-3].ival, yyvsp[-2].strval, yyvsp[-1].ival); ;
    break;}
case 192:
#line 1052 "parser.y"
{ yyval.index = do_XMLTag(yyvsp[0].strval, 1, 0, NULL, 0); ;
    break;}
case 193:
#line 1055 "parser.y"
{ yyval.ival = yyvsp[0].ival; ;
    break;}
case 194:
#line 1056 "parser.y"
{ yyval.ival = OP_EQUAL | OP_NOT; ;
    break;}
case 195:
#line 1057 "parser.y"
{ yyval.ival = OP_EQUAL; ;
    break;}
case 196:
#line 1058 "parser.y"
{ yyval.ival = OP_EQUAL; ;
    break;}
case 197:
#line 1063 "parser.y"
{ yyval.index = do_NamedWfPattern(yyvsp[-2].ival, yyvsp[-1].strval, yyvsp[0].index); ;
    break;}
case 198:
#line 1067 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 199:
#line 1068 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 200:
#line 1071 "parser.y"
{ yyval.strval = yyvsp[0].strval; ;
    break;}
case 201:
#line 1072 "parser.y"
{ yyval.strval = NULL; ;
    break;}
case 202:
#line 1075 "parser.y"
{ yyval.index = do_WordformPattern(yyvsp[0].boolt, 0); ;
    break;}
case 203:
#line 1076 "parser.y"
{ yyval.index = do_WordformPattern(yyvsp[0].boolt, 1); ;
    break;}
case 204:
#line 1079 "parser.y"
{ yyval.boolt = do_StringConstraint(yyvsp[-1].strval, yyvsp[0].ival); ;
    break;}
case 205:
#line 1080 "parser.y"
{ yyval.boolt = NULL;
                                        if (!FindVariable(yyvsp[0].strval)) {
					  cqpmessage(Error, 
						     "%s: no such variable", 
						     yyvsp[0].strval);
					  generate_code = 0;
					}
					else {
					  yyval.boolt = do_SimpleVariableReference(yyvsp[0].strval);
					}
					free(yyvsp[0].strval);
	                              ;
    break;}
case 206:
#line 1092 "parser.y"
{ yyval.boolt = yyvsp[-1].boolt; ;
    break;}
case 207:
#line 1093 "parser.y"
{ if (generate_code) {
					  NEW_BNODE(yyval.boolt);
					  yyval.boolt->constnode.type = cnode;
					  yyval.boolt->constnode.val  = 1;
	                                }
                                      ;
    break;}
case 208:
#line 1101 "parser.y"
{ yyval.boolt = yyvsp[-1].boolt; ;
    break;}
case 209:
#line 1102 "parser.y"
{ if (generate_code) {
					  NEW_BNODE(yyval.boolt);
					  yyval.boolt->constnode.type = cnode;
					  yyval.boolt->constnode.val  = 1;
	                                }
                                      ;
    break;}
case 210:
#line 1110 "parser.y"
{ int flags, i;
					  flags = 0;

					  for (i = 0; yyvsp[0].strval[i] != '\0'; i++) {
					    switch (yyvsp[0].strval[i]) {
					    case 'c':
					      flags |= IGNORE_CASE;
					      break;
					    case 'd':
					      flags |= IGNORE_DIAC;
					      break;
					    case 'l':
					      flags = IGNORE_REGEX; /* literal */
					      break;
					    default:
					      cqpmessage(Warning, "Unknown flag %s%c (ignored)", "%", yyvsp[0].strval[i]);
					      break;
					    }
					  }

					  /* %l supersedes all others */
					  if (flags & IGNORE_REGEX) {
					    if (flags != IGNORE_REGEX) {
					      cqpmessage(Warning, "%s and %s flags cannot be combined with %s (ignored)",
							 "%c", "%d", "%l");
					    }
					    flags = IGNORE_REGEX;
					  }

					  yyval.ival = flags;
					;
    break;}
case 211:
#line 1141 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 212:
#line 1144 "parser.y"
{ yyval.boolt = yyvsp[0].boolt; ;
    break;}
case 213:
#line 1145 "parser.y"
{ yyval.boolt = NULL; ;
    break;}
case 214:
#line 1150 "parser.y"
{ prepare_AlignmentConstraints(yyvsp[0].strval); ;
    break;}
case 215:
#line 1152 "parser.y"
{ if (generate_code)
			                   CurEnv->negated = yyvsp[-1].ival;
                                       ;
    break;}
case 216:
#line 1155 "parser.y"
{ ;
    break;}
case 217:
#line 1158 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 218:
#line 1159 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 219:
#line 1163 "parser.y"
{ if (generate_code) {
		    CurEnv->search_context.direction = yyvsp[-1].direction;
		    CurEnv->search_context.type = yyvsp[0].context.type;
		    CurEnv->search_context.size = yyvsp[0].context.size;
		    CurEnv->search_context.attrib = yyvsp[0].context.attrib;
		  }
		;
    break;}
case 220:
#line 1170 "parser.y"
{ if (generate_code) {
					    CurEnv->search_context.type  = word;
					    CurEnv->search_context.size  = hard_boundary;
					    CurEnv->search_context.attrib = NULL;
					  }
					;
    break;}
case 221:
#line 1178 "parser.y"
{ yyval.ival = abs(yyvsp[0].ival); ;
    break;}
case 222:
#line 1179 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 223:
#line 1182 "parser.y"
{ yyval.ival = yyvsp[0].ival; ;
    break;}
case 224:
#line 1183 "parser.y"
{ yyval.ival = 1; ;
    break;}
case 225:
#line 1186 "parser.y"
{ yyval.ival = yyvsp[0].ival; ;
    break;}
case 226:
#line 1187 "parser.y"
{ yyval.ival = 0; ;
    break;}
case 227:
#line 1190 "parser.y"
{ yyval.ival = yyvsp[0].ival; ;
    break;}
case 228:
#line 1191 "parser.y"
{ yyval.ival = repeat_inf; ;
    break;}
case 229:
#line 1195 "parser.y"
{ expansion.direction = yyvsp[-2].direction;
					  expansion.type = yyvsp[0].context.type;
					  expansion.size = yyvsp[0].context.size;
					  expansion.attrib = yyvsp[0].context.attrib;
					;
    break;}
case 230:
#line 1200 "parser.y"
{ expansion.direction = leftright;
					  expansion.type = word;
					  expansion.size = 0;
					  expansion.attrib = NULL;
					;
    break;}
case 231:
#line 1207 "parser.y"
{ yyval.direction = left; ;
    break;}
case 232:
#line 1208 "parser.y"
{ yyval.direction = right; ;
    break;}
case 233:
#line 1209 "parser.y"
{ yyval.direction = leftright; ;
    break;}
case 234:
#line 1212 "parser.y"
{ do_Description(&(yyval.context), yyvsp[-1].ival, yyvsp[0].strval); ;
    break;}
case 235:
#line 1213 "parser.y"
{ do_Description(&(yyval.context), yyvsp[0].ival, NULL); ;
    break;}
case 236:
#line 1216 "parser.y"
{ yyval.cl = yyvsp[0].cl; ;
    break;}
case 237:
#line 1217 "parser.y"
{ yyval.cl = findcorpus("Last", UNDEF, 0); ;
    break;}
case 238:
#line 1221 "parser.y"
{ CorpusList *cl;

                                          cqpmessage(Message, "CID: %s", yyvsp[0].strval);

					  if ((cl = findcorpus(yyvsp[0].strval, UNDEF, 1)) == NULL) {
					    cqpmessage(Error,
						       "Corpus ``%s'' is undefined", yyvsp[0].strval);
					    generate_code = 0;
					    yyval.cl = NULL;
					  }
					  else if (!access_corpus(cl)) {
					    cqpmessage(Warning,
						       "Corpus ``%s'' can't be accessed", yyvsp[0].strval);
					    yyval.cl = NULL;
					  }
					  else
					    yyval.cl = cl;
                                        ;
    break;}
case 239:
#line 1241 "parser.y"
{ yyval.boolt = bool_implies(yyvsp[-2].boolt, yyvsp[0].boolt); ;
    break;}
case 240:
#line 1242 "parser.y"
{ yyval.boolt = bool_or(yyvsp[-2].boolt, yyvsp[0].boolt); ;
    break;}
case 241:
#line 1243 "parser.y"
{ yyval.boolt = bool_and(yyvsp[-2].boolt, yyvsp[0].boolt); ;
    break;}
case 242:
#line 1244 "parser.y"
{ yyval.boolt = yyvsp[-1].boolt; ;
    break;}
case 243:
#line 1245 "parser.y"
{ yyval.boolt = bool_not(yyvsp[0].boolt); ;
    break;}
case 244:
#line 1246 "parser.y"
{ yyval.boolt = yyvsp[0].boolt; ;
    break;}
case 245:
#line 1249 "parser.y"
{ yyval.boolt = do_RelExpr(yyvsp[-2].boolt, yyvsp[-1].boolo, yyvsp[0].boolt); ;
    break;}
case 246:
#line 1251 "parser.y"
{
                 if (yyvsp[-2].ival & OP_NOT) {
                   yyval.boolt = do_RelExpr(yyvsp[-3].boolt, cmp_neq, do_mval_string(yyvsp[-1].strval, yyvsp[-2].ival, yyvsp[0].ival));
		 }
                 else {
                   yyval.boolt = do_RelExpr(yyvsp[-3].boolt, cmp_eq,  do_mval_string(yyvsp[-1].strval, yyvsp[-2].ival, yyvsp[0].ival));
                 }
              ;
    break;}
case 247:
#line 1259 "parser.y"
{ yyval.boolt = do_RelExExpr(yyvsp[0].boolt); ;
    break;}
case 248:
#line 1262 "parser.y"
{yyval.ival = OP_CONTAINS | yyvsp[-1].ival;;
    break;}
case 249:
#line 1263 "parser.y"
{yyval.ival = OP_MATCHES  | yyvsp[-1].ival;;
    break;}
case 250:
#line 1266 "parser.y"
{yyval.ival = OP_NOT;;
    break;}
case 251:
#line 1267 "parser.y"
{yyval.ival = 0;;
    break;}
case 252:
#line 1270 "parser.y"
{ yyval.boolt = do_LabelReference(yyvsp[0].strval, 0); ;
    break;}
case 253:
#line 1271 "parser.y"
{ yyval.boolt = do_LabelReference(yyvsp[0].strval, 1); ;
    break;}
case 254:
#line 1272 "parser.y"
{ yyval.boolt = do_IDReference(yyvsp[0].strval, 0); ;
    break;}
case 255:
#line 1273 "parser.y"
{ yyval.boolt = do_IDReference(yyvsp[0].strval, 1); ;
    break;}
case 256:
#line 1274 "parser.y"
{ yyval.boolt = do_IDReference(cl_strdup(field_type_to_name(yyvsp[0].field)), 0); ;
    break;}
case 257:
#line 1275 "parser.y"
{ yyval.boolt = yyvsp[0].boolt; ;
    break;}
case 258:
#line 1278 "parser.y"
{ yyval.boolt = yyvsp[0].boolt; ;
    break;}
case 259:
#line 1279 "parser.y"
{ yyval.boolt = do_flagged_string(yyvsp[-1].strval, yyvsp[0].ival); ;
    break;}
case 260:
#line 1281 "parser.y"
{ 
					  yyval.boolt = do_flagged_re_variable(yyvsp[-2].strval, yyvsp[0].ival); 
					;
    break;}
case 261:
#line 1284 "parser.y"
{ if (generate_code) {
		                            if (!FindVariable(yyvsp[0].strval)) {
					      cqpmessage(Error, 
							 "%s: no such variable", 
							 yyvsp[0].strval);
					      generate_code = 0;
					      yyval.boolt = NULL;
					    }
					    else {
					      NEW_BNODE(yyval.boolt);
					      yyval.boolt->type = var_ref;
					      yyval.boolt->varref.varName = yyvsp[0].strval;
					    }
		                          }
                                          else
					    yyval.boolt = NULL;
		                        ;
    break;}
case 262:
#line 1301 "parser.y"
{ if (generate_code) {
					    NEW_BNODE(yyval.boolt);
					    yyval.boolt->type = int_leaf;
					    yyval.boolt->leaf.ctype.iconst = yyvsp[0].ival;
					  }
		                          else
					    yyval.boolt = NULL;
					;
    break;}
case 263:
#line 1309 "parser.y"
{ if (generate_code) {
					    NEW_BNODE(yyval.boolt);
					    yyval.boolt->type = float_leaf;
					    yyval.boolt->leaf.ctype.fconst = yyvsp[0].fval;
					  }
		                          else
					    yyval.boolt = NULL;
                                        ;
    break;}
case 264:
#line 1319 "parser.y"
{ yyval.boolo = cmp_lt; ;
    break;}
case 265:
#line 1320 "parser.y"
{ yyval.boolo = cmp_gt; ;
    break;}
case 266:
#line 1321 "parser.y"
{ yyval.boolo = cmp_eq; ;
    break;}
case 267:
#line 1322 "parser.y"
{ yyval.boolo = cmp_neq; ;
    break;}
case 268:
#line 1323 "parser.y"
{ yyval.boolo = cmp_let; ;
    break;}
case 269:
#line 1324 "parser.y"
{ yyval.boolo = cmp_get; ;
    break;}
case 270:
#line 1327 "parser.y"
{ yyval.boolt = FunctionCall(yyvsp[-3].strval, yyvsp[-1].apl); ;
    break;}
case 271:
#line 1330 "parser.y"
{ yyval.apl = yyvsp[0].apl;
					    ;
    break;}
case 272:
#line 1333 "parser.y"
{ ActualParamList *last;

					      if (generate_code) {
						assert(yyvsp[-2].apl != NULL);

						last = yyvsp[-2].apl;
						while (last->next != NULL)
						  last = last->next;
						last->next = yyvsp[0].apl;
						yyval.apl = yyvsp[-2].apl;
					      }
					      else
						yyval.apl = NULL;
					    ;
    break;}
case 273:
#line 1349 "parser.y"
{ if (generate_code) {
                                             New(yyval.apl, ActualParamList);

					     yyval.apl->param = yyvsp[0].boolt;
					     yyval.apl->next = NULL;
					   }
					   else
					     yyval.apl = NULL;
                                         ;
    break;}
case 274:
#line 1360 "parser.y"
{ yyval.strval = yyvsp[0].strval; ;
    break;}
case 275:
#line 1363 "parser.y"
{ yyval.evalt = yyvsp[0].evalt; ;
    break;}
case 276:
#line 1364 "parser.y"
{ yyval.evalt = yyvsp[0].evalt; ;
    break;}
case 277:
#line 1365 "parser.y"
{ if (generate_code) {
					    NEW_EVALLEAF(yyval.evalt, yyvsp[0].index);
					  }
					  else
					    yyval.evalt = NULL;
		                        ;
    break;}
case 278:
#line 1377 "parser.y"
{ yyval.evalt = do_MeetStatement(yyvsp[-3].evalt, yyvsp[-2].evalt, &(yyvsp[-1].context)); ;
    break;}
case 279:
#line 1381 "parser.y"
{ yyval.context.type = word;
					  yyval.context.size = yyvsp[-1].ival;
					  yyval.context.size2 = yyvsp[0].ival;
					  yyval.context.attrib = NULL;
					;
    break;}
case 280:
#line 1386 "parser.y"
{ do_StructuralContext(&(yyval.context), yyvsp[0].strval); ;
    break;}
case 281:
#line 1387 "parser.y"
{ yyval.context.type = word;
					  yyval.context.size = 1;
					  yyval.context.size2 = 1;
					  yyval.context.attrib = NULL;
					;
    break;}
case 282:
#line 1398 "parser.y"
{ yyval.evalt = do_UnionStatement(yyvsp[-2].evalt, yyvsp[-1].evalt); ;
    break;}
case 283:
#line 1403 "parser.y"
{ yyval.cl = do_TABQuery(yyvsp[-1].evalt); ;
    break;}
case 284:
#line 1408 "parser.y"
{ yyval.evalt = make_first_tabular_pattern(yyvsp[-1].index, yyvsp[0].evalt); ;
    break;}
case 285:
#line 1413 "parser.y"
{ yyval.evalt = add_tabular_pattern(yyvsp[-2].evalt, &(yyvsp[-1].context), yyvsp[0].index); ;
    break;}
case 286:
#line 1415 "parser.y"
{ yyval.evalt = NULL; ;
    break;}
case 287:
#line 1418 "parser.y"
{ do_OptDistance(&(yyval.context), yyvsp[-1].ival, yyvsp[-1].ival); ;
    break;}
case 288:
#line 1420 "parser.y"
{ do_OptDistance(&(yyval.context), yyvsp[-3].ival, yyvsp[-1].ival); ;
    break;}
case 289:
#line 1421 "parser.y"
{ do_OptDistance(&(yyval.context), 0, yyvsp[-1].ival); ;
    break;}
case 290:
#line 1422 "parser.y"
{ do_OptDistance(&(yyval.context), 0, 0); ;
    break;}
case 291:
#line 1427 "parser.y"
{ add_user_to_list(yyvsp[-1].strval, yyvsp[0].strval); ;
    break;}
case 293:
#line 1429 "parser.y"
{ add_host_to_list(yyvsp[0].strval); ;
    break;}
case 294:
#line 1430 "parser.y"
{ add_hosts_in_subnet_to_list(yyvsp[0].strval); ;
    break;}
case 295:
#line 1431 "parser.y"
{ add_host_to_list(NULL); ;
    break;}
case 298:
#line 1440 "parser.y"
{ add_grant_to_last_user(yyvsp[0].strval); ;
    break;}
case 300:
#line 1446 "parser.y"
{
					 	if (enable_macros) 
						  define_macro(yyvsp[-4].strval, yyvsp[-2].ival, NULL, yyvsp[0].strval);  /* <macro.c> */
						else 
						  cqpmessage(Error, "CQP macros not enabled.");
						free(yyvsp[0].strval);  /* don't forget to free the allocated strings */
						free(yyvsp[-4].strval);
						;
    break;}
case 301:
#line 1455 "parser.y"
{
					 	if (enable_macros) 
						  define_macro(yyvsp[-4].strval, 0, yyvsp[-2].strval, yyvsp[0].strval);  /* <macro.c> */
						else 
						  cqpmessage(Error, "CQP macros not enabled.");
						free(yyvsp[0].strval);  /* don't forget to free the allocated strings */
						free(yyvsp[-2].strval);
						free(yyvsp[-4].strval);
						;
    break;}
case 302:
#line 1464 "parser.y"
{
		  				load_macro_file(yyvsp[0].strval);
						free(yyvsp[0].strval);  /* don't forget to free the allocated string */
		                                ;
    break;}
case 305:
#line 1475 "parser.y"
{
					  list_macros(NULL);
					;
    break;}
case 306:
#line 1478 "parser.y"
{
					  list_macros(yyvsp[0].strval);
					  free(yyvsp[0].strval);
					;
    break;}
case 307:
#line 1483 "parser.y"
{
					  print_macro_definition(yyvsp[-3].strval, yyvsp[-1].ival);
					  free(yyvsp[-3].strval);
					;
    break;}
case 308:
#line 1491 "parser.y"
{
					  int l1 = strlen(yyvsp[-1].strval), l2 = strlen(yyvsp[0].strval);
					  char *s = (char *) cl_malloc(l1 + l2 + 2);
					  strcpy(s, yyvsp[-1].strval); s[l1] = ' ';
					  strcpy(s+l1+1, yyvsp[0].strval);
					  s[l1+l2+1] = '\0';
					  free(yyvsp[-1].strval);
					  free(yyvsp[0].strval);
					  yyval.strval = s;
					;
    break;}
case 309:
#line 1501 "parser.y"
{ yyval.strval = yyvsp[0].strval; ;
    break;}
case 310:
#line 1505 "parser.y"
{ cl_randomize(); ;
    break;}
case 311:
#line 1506 "parser.y"
{ cl_set_seed(yyvsp[0].ival); ;
    break;}
case 313:
#line 1514 "parser.y"
{ yyval.field = yyvsp[0].field; ;
    break;}
case 314:
#line 1515 "parser.y"
{ yyval.field = NoField; ;
    break;}
case 323:
#line 1531 "parser.y"
{ yyval.Anchor.anchor = yyvsp[0].field; yyval.Anchor.offset = 0; ;
    break;}
case 324:
#line 1532 "parser.y"
{ yyval.Anchor.anchor = yyvsp[-3].field; yyval.Anchor.offset = yyvsp[-1].ival; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1535 "parser.y"


